<?php
class forum_mmoo_content{
	var $request;
	var $needMemberInfo;
	var $memberInfo = array();
	var $needLinkToList = true;
	var $topLinks = array();
	var $outputHead = '';
	var $outputMain = '';
	var $outputSocialButtonsUrl = '';
	var $outputSocialButtons = '';
	
	function __construct($request=array(), $needMemberInfo=true){
		$this->request = $request;
		$this->needMemberInfo = $needMemberInfo;
		if( $this->needMemberInfo ){
			$this->setMemberInfo();
		}
	}
	
	function setMemberInfo(){
		if( !$this->setInfoWithSession() ){
			include_once(FORUM_MMOO_CONTENT_DIR.'_login_class.php');
			$objLogin = new forum_mmoo_login_class();
			if( !$objLogin->checkLogin() ){
				$memberId = 0;
			}else{
				$memberId = $objLogin->memberId;
			}
			$this->setMemberInfoWithDb( $memberId );
		}
	}
	
	function setInfoWithSession(){
		$sessionData = forum_mmoo_get_session();
		if( !empty($sessionData['memberInfo']) ){
			$this->memberInfo = $sessionData['memberInfo'];
			return true;
		}
		return false;
	}
	
	function setMemberInfoWithDb( $memberId ){
		$this->memberInfo['member_id'] = $memberId;
		
		include_once(FORUM_MMOO_DATA_DIR.'data_group.php');
		$objGroup = new forum_mmoo_data_group();
		
		if( $memberId > 0 ){
			include_once(FORUM_MMOO_DATA_DIR.'data_members.php');
			$objMembers = new forum_mmoo_data_members();
			$result = $objMembers->getMemberInfoById( $memberId , 'strict' );
			$this->memberInfo['mail'] = $result['mail'];
			$this->memberInfo['hn'] = $result['hn'];
			$groupData = $objGroup->getGroupData($result['group_id']);
		}else{
			$this->memberInfo['mail'] = '';
			$this->memberInfo['hn'] = '';
			$groupData = $objGroup->getGuestData();
		}
		
		$authParams = $objGroup->getAuthParams();
		foreach($authParams as $param){
			$this->memberInfo[$param] = $groupData[$param];
		}
		
		forum_mmoo_set_session( 'memberInfo', $this->memberInfo );
	}
	
	function setBackPage(){
	}
	
	function setOutputHead(){
		if( $this->needLinkToList ){
			$sessionData = forum_mmoo_get_session();
			if( empty($sessionData['listPage']) ){
				$toListOption = array();
			}else{
				$toListOption = array('forum_mmoo_page'=>$sessionData['listPage']);
			}
			array_unshift( $this->topLinks , array('act'=>'list', 'option'=>$toListOption, 'text'=>'TOPICS') );
		}
		if( !empty($this->topLinks) ){
			$this->outputHead .= '<p>';
			foreach($this->topLinks as $link){
				$this->outputHead .= '<a class="top_link" href="'.forum_mmoo_make_content_url($link['act'], $link['option']).'">'.$link['text'].'</a>';
			}
			$this->outputHead .= '</p>';
		}
		
		if( $this->needMemberInfo ){
			if( $this->memberInfo['member_id'] > 0 ){
				$this->outputHead .= '<p class="forum_mmoo-right">';
				$this->outputHead .= '<span class="forum_mmoo-hello">';
				$this->outputHead .= 'Hello,';
				if( strlen($this->memberInfo['hn']) > 0 ){
					$this->outputHead .= '&nbsp;'.forum_mmoo_excerpt($this->memberInfo['hn'],FORUM_MMOO_HN_SHORTEN);
				}
				$this->outputHead .= '</span>';
				$this->outputHead .= '<a class="login_link" href="'.forum_mmoo_make_content_url('logout').'">Sign Out</a>';
				$this->outputHead .= '<a class="login_link" href="'.forum_mmoo_make_content_url('edit_profile').'">Profile</a>';
				if( $this->memberInfo['send_message']==FORUM_MMOO_FLAG_YES ){
					$this->outputHead .= '<a class="login_link" href="'.forum_mmoo_make_content_url('message').'">Messages</a>';
				}
				$this->outputHead .= '</p>';
			}else{
				include_once(FORUM_MMOO_DATA_DIR.'data_group.php');
				$objDataGroup = new forum_mmoo_data_group();
				$groups = $objDataGroup->getGroupsNoneGuest();
				if( count($groups) > 0 ){
					$this->outputHead .= '<p class="forum_mmoo-right">';
					$this->outputHead .= '<a class="login_link" href="'.forum_mmoo_make_content_url('login').'">SIGN IN</a>';
					$this->outputHead .= '<a class="login_link" href="'.forum_mmoo_make_content_url('register').'">new here? Sign Up</a>';
					$this->outputHead .= '</p>';
				}
			}
		}
	}
	
	function setOutputSocialButtons(){
		if( empty($this->outputSocialButtonsUrl) ){
			$this->outputSocialButtons = '';
		}else{
			include_once(FORUM_MMOO_DATA_DIR.'data_general.php');
			$objGeneral = new forum_mmoo_data_general();
			$generalInfo = $objGeneral->getData();
			
			if( !empty($generalInfo['social']) ){
				include_once(FORUM_MMOO_FUNCTIONS_DIR.'social_button.php');
				$buttons = unserialize($generalInfo['social']);
				$this->outputSocialButtons .= '<div id="forum_mmoo-social_buttons">';
				$javascriptArrButtons = '[';
				$and = '';
				foreach($buttons as $button => $buttonOption){
					$this->outputSocialButtons .= forum_mmoo_get_social_button($button, $buttonOption, $this->outputSocialButtonsUrl);
					$javascriptArrButtons .= $and."'".$button."'";
					$and = ',';
				}
				$this->outputSocialButtons .= '</div>';
				$javascriptArrButtons .= ']';
				$this->outputSocialButtons .= '<script type="text/javascript">forum_mmoo_mend_social_height('.$javascriptArrButtons.');</script>';
			}
		}
	}
	
	function copyOutputMain($act, $request=array() ){
		$validActs = forum_mmoo_get_valid_content_actions();
		if( empty($act) || !in_array($act, $validActs) ){
			return '';
		}
		$copyClassName = "forum_mmoo_content_".$act;
		include_once( FORUM_MMOO_CONTENT_DIR."content_".$act.".php");
		$objCopy = new $copyClassName( $request );
		$objCopy->memberInfo = $this->memberInfo;
		$objCopy->setOutputMain();
		$objCopy->setBackPage();
		$this->outputSocialButtonsUrl = $objCopy->outputSocialButtonsUrl;
		return $objCopy->outputMain;
	}
	
	function getMemberLink($memberId){
		if( empty($memberId) ){
			return FORUM_MMOO_HN_ANONYMOUS;
		}
		
		if( empty($this->objMembers) ){
			include_once(FORUM_MMOO_DATA_DIR.'data_members.php');
			$this->objMembers = new forum_mmoo_data_members();
		}
		$result = $this->objMembers->getMemberInfoById( $memberId , 'strict' );
		if( empty($result) ){
			return FORUM_MMOO_HN_ANONYMOUS;
		}
		
		$hn = forum_mmoo_excerpt($result['hn'],FORUM_MMOO_HN_SHORTEN);
		if( strlen($hn) == 0 ){
			$hn = FORUM_MMOO_HN_ANONYMOUS;
		}
		return '<a href="'.forum_mmoo_make_content_url('profile', array('forum_mmoo_member'=>$memberId) ).'">'.$hn.'</a>';
	}
}
?>