<?php
class forum_mmoo_login_class{
	var $memberId = null;
	
	function __construct(){
	}
	
	function checkLogin(){
		if( $this->checkSession() ){
			return true;
		}
		
		if( $this->checkCookie() ){
			return true;
		}
		
		return false;
	}
	
	function checkSession(){
		$sessionData = forum_mmoo_get_session();
		if( !empty($sessionData['member_id']) ){
			$this->memberId = $sessionData['member_id'];
			return true;
		}
		return false;
	}
	
	function checkCookie(){
		$cookieData = forum_mmoo_get_cookie();
		if( !empty($cookieData['for_login']) ){
			if( $this->tryLogin($cookieData['for_login'],true) ){
				return true;
			}else{
				$this->clearCookie();
				return false;
			}
		}
		return false;
	}
	
	function saveSession(){
		forum_mmoo_set_session('member_id', $this->memberId);
	}
	
	function clearCookie(){
		forum_mmoo_unset_cookie('for_login');
	}
	
	function saveCookie($info){
		$this->clearCookie();
		forum_mmoo_set_cookie( 'for_login', $info );
	}
	
	function tryLogin( $forLogin, $updateCookie=true ){
		include_once(FORUM_MMOO_DATA_DIR.'data_members.php');
		$objMembers = new forum_mmoo_data_members();
		$memberInfo = $objMembers->getMemberInfoByLoginData( $forLogin , 'strict' );
		if( empty($memberInfo) ){
			return false;
		}
		$this->memberId = $memberInfo['id'];
		
		$this->saveSession();
		if( $updateCookie ){
			$this->saveCookie($forLogin);
		}
		return true;
	}
	
	function logout(){
		forum_mmoo_unset_session();
		$this->clearCookie();
	}
}
?>
