<?php
class forum_mmoo_content_list extends forum_mmoo_content{
	function __construct($request=array()){
		parent::__construct($request);
		$this->needLinkToList = false;
		unset($request['act']);
		$this->outputSocialButtonsUrl = forum_mmoo_make_content_url('list', $request);
	}
	
	function setBackPage(){
		forum_mmoo_unset_session( 'backPage' );
		
		if( empty($this->request['forum_mmoo_page']) ){
			forum_mmoo_unset_session( 'listPage' );
		}else{
			forum_mmoo_set_session( 'listPage', $this->request['forum_mmoo_page'] );
		}
	}
	
	function setOutputMain(){
		if( $this->memberInfo['read_only'] == FORUM_MMOO_FLAG_NO ){
			$this->outputMain .= '<p class="forum_mmoo-alert">'.FORUM_MMOO_MUST_LOGIN_MESSAGE.' to view posts.<p>';
		}else{
			include_once(FORUM_MMOO_DATA_DIR.'data_general.php');
			$objGeneral = new forum_mmoo_data_general();
			$generalInfo = $objGeneral->getData();
			
			$sortKey = $generalInfo['sort_topic'];
			$sortSql = $objGeneral->sort_topic[$sortKey]['sql'];
			
			$page = empty($this->request['forum_mmoo_page']) ? 1 : $this->request['forum_mmoo_page'];
			
			include_once(FORUM_MMOO_DATA_DIR.'data_topics.php');
			$objTopics = new forum_mmoo_data_topics();
			$topics = $objTopics->getData(get_the_ID(), $sortSql, $generalInfo['topic_per_page'], $page);
			
			$topicNum = $objTopics->getTopicNum(get_the_ID());
			$paginateArgs = array(
				'base' => forum_mmoo_make_content_url('list').'%_%'
				, 'format' => forum_mmoo_get_paginate_format('forum_mmoo_page')
				, 'total' => ceil( $topicNum / $generalInfo['topic_per_page'] )
				, 'current' => $page
				, 'show_all' => false
				, 'prev_next' => true
				, 'prev_text' => ' << prev '
				, 'next_text' => ' next >> '
				, 'end_size' => 3
				, 'mid_size' => 5
				, 'type' => 'plain'
			);
			
			$this->outputMain .= '<span class="forum_mmoo-page_title">TOPICS</span>';
			if( empty($topics) ){
				$this->outputMain .= '<p>No topics made yet.</p>';
			}else{
				$this->outputMain .= '<div class="forum_mmoo-paginate_links">'.paginate_links($paginateArgs).'</div>';
				$this->outputMain .= '<table class="forum_mmoo-table_list">';
				$this->outputMain .= '<tr>';
				$this->outputMain .= '<th>TOPIC</th>';
				$this->outputMain .= '<th style="width:4em;">POSTS</th>';
				if( $this->memberInfo['notify_update'] == FORUM_MMOO_FLAG_YES ){
					$this->outputMain .= '<th colspan="2">Notifying Mail</th>';
					include_once(FORUM_MMOO_DATA_DIR.'data_notify_topic.php');
					$objNotifyTopic = new forum_mmoo_data_notify_topic();
					$notify = $objNotifyTopic->getDataForMember($this->memberInfo['member_id']);
				}
				if( $this->memberInfo['delete_topic'] == FORUM_MMOO_FLAG_YES ){
					$this->outputMain .= '<th>DELETE</th>';
				}
				$cnt = 0;
				foreach($topics as $topic){
					include_once(FORUM_MMOO_DATA_DIR.'data_thread.php');
					$objThread = new forum_mmoo_data_thread($topic['id']);
					$threadInfo = $objThread->getLastUpdate();
					
					$cnt++;
					if( $cnt % 2 == 1){
						$this->outputMain .= '<tr class="even">';
						$newImageFileName = 'new.jpg';
					}else{
						$this->outputMain .= '<tr class="odd">';
						$newImageFileName = 'new_bgdda0dd.jpg';
					}
					$this->outputMain .= '<td class="topic">';
					$this->outputMain .= '<a href="'.forum_mmoo_make_content_url('posts',array('forum_mmoo_topic'=>$topic['id'])).'">';
					$this->outputMain .= forum_mmoo_excerpt($topic['title'],FORUM_MMOO_TOPIC_SHORTEN);
					$this->outputMain .= '</a>';
					
					if( empty($this->memberInfo['member_id']) ){
						$showNew = false;
					}else{
						$cookieData = forum_mmoo_get_cookie();
						$lastSeen = $cookieData['seen'][$this->memberInfo['member_id']][$topic['id']];
						if( empty($lastSeen) ){
							$showNew = true;
						}else{
							if( $topic['updated_time'] > $lastSeen ){
								$showNew = true;
							}elseif($threadInfo['updated_time'] > $lastSeen ){
								$showNew = true;
							}else{
								$showNew = false;
							}
						}
					}
					
					if( $showNew ){
						$this->outputMain .= '<img src="'.FORUM_MMOO_FILE_URL.'/image/'.$newImageFileName.'" alt="new">';
					}
					
					$this->outputMain .= '<div class="forum_mmoo-list_detail">';
					$this->outputMain .= 'created by : '.$this->getMemberLink($topic['created_by']).'&nbsp;&nbsp;'.forum_mmoo_convert_datetime_compact($topic['updated_time']);
					if( !empty($threadInfo) ){
						$this->outputMain .= '<br>last update : ';
						$this->outputMain .= '<a href="'.forum_mmoo_make_content_url('posts',array('forum_mmoo_topic'=>$topic['id'], 'forum_mmoo_post'=>$threadInfo['id'])).'">';
						$threadTitle = forum_mmoo_excerpt($threadInfo['title'], FORUM_MMOO_POST_SHORTEN);
						if( strlen($threadTitle) == 0 ){
							$threadTitle = 'No Title';
						}
						$this->outputMain .= $threadTitle;
						$this->outputMain .= '</a>&nbsp;&nbsp;';
						$this->outputMain .= 'by : '.$this->getMemberLink($threadInfo['posted_by']).'&nbsp;&nbsp;';
						$this->outputMain .= forum_mmoo_convert_datetime_compact($threadInfo['updated_time']);
					}
					$this->outputMain .= '</div>';
					
					$this->outputMain .= '</td>';
					$this->outputMain .= '<td class="buttons">'.(int)$objThread->getCntRows().'</td>';
					if( $this->memberInfo['notify_update'] == FORUM_MMOO_FLAG_YES ){
						if( $notify[$topic['id']] ){
							$this->outputMain .= '<td class="buttons" style="width:3.5em;">receiving</td>';
							$this->outputMain .= '<td class="buttons" style="width:4.5em;"><a class="forum_mmoo-psudo_button" style="margin:0;" href="'.forum_mmoo_make_content_url('notify_topic',array('forum_mmoo_topic'=>$topic['id'], 'change'=>'stop')).'">Stop</a>';
						}else{
							$this->outputMain .= '<td class="buttons" style="width:3.5em;">not receiving</td>';
							$this->outputMain .= '<td class="buttons" style="width:4.5em;"><a class="forum_mmoo-psudo_button" style="margin:0;" href="'.forum_mmoo_make_content_url('notify_topic',array('forum_mmoo_topic'=>$topic['id'], 'change'=>'start')).'">Start</a>';
						}
					}
					if( $this->memberInfo['delete_topic'] == FORUM_MMOO_FLAG_YES ){
						$this->outputMain .= '<td class="buttons" style="width:4.5em;">';
						$this->outputMain .= '<a class="forum_mmoo-psudo_button" style="margin:0;" href="'.forum_mmoo_make_content_url('delete_topic',array('forum_mmoo_topic'=>$topic['id'])).'">Delete</a>';
						$this->outputMain .= '</td>';
					}
					$this->outputMain .= '</tr>';
				}
				$this->outputMain .= '</table>';
				$this->outputMain .= '<div class="forum_mmoo-paginate_links">'.paginate_links($paginateArgs).'</div>';
			}
			if( $this->memberInfo['create_topic'] == FORUM_MMOO_FLAG_YES ){
				$this->outputMain .= '<span class="forum_mmoo-page_title">Create a New Topic</span>';
				$this->outputMain .= '<form name="forum_mmoo_form" method="post" action="'.forum_mmoo_make_content_url('create_topic').'">';
				$this->outputMain .= '<span class="forum_mmoo-label_topic_title">TITLE : </span><input type="text" class="forum_mmoo-topic_title" name="forum_mmoo_topic_title">';
				$this->outputMain .= '<input type="hidden" name="created_by" value="'.$this->memberInfo['member_id'].'">';
				$this->outputMain .= '&nbsp;&nbsp;<span class="forum_mmoo-psudo_button" onClick="document.forum_mmoo_form.submit();">Create!</span>';
				$this->outputMain .= '</form>';
			}
		}
	}
}
?>