<?php
class forum_mmoo_content_message extends forum_mmoo_content{
	function __construct($request=array()){
		parent::__construct($request);
	}
	
	function setBackPage(){
		$backPage = array(
			'act' => 'message'
			, 'option' => array( 'forum_mmoo_current' => 'inbox' )
			, 'text' => 'Messages'
		);
		forum_mmoo_set_session( 'backPage', $backPage );
	}
	
	function setOutputMain(){
		if( $this->memberInfo['send_message']==FORUM_MMOO_FLAG_NO ){
			$this->outputMain .= '<p class="forum_mmoo-alert">'.FORUM_MMOO_MUST_LOGIN_MESSAGE.' to send/receive messages.<p>';
		}else{
			include_once(FORUM_MMOO_DATA_DIR.'data_message.php');
			$this->objMessage = new forum_mmoo_data_message();
			
			if( empty($this->request['forum_mmoo_current']) ){
				$this->request['forum_mmoo_current'] = 'inbox';
			}
			
			$this->outputMain .= '<div id="forum_mmoo-message_menu">';
			$this->outputMain .= '<div class="forum_mmoo-is_main">'.$this->getMenuButton('new_message', 'NEW MESSAGE').'</div>';
			$this->outputMain .= '<div class="forum_mmoo-is_main">'.$this->getMenuButton('inbox', 'INBOX').'</div>';
			$this->outputMain .= '<div class="forum_mmoo-is_main">'.$this->getMenuButton('outbox', 'OUTBOX').'</div>';
			$this->outputMain .= '<div class="forum_mmoo-is_main">'.$this->getMenuButton('draft', 'DRAFT').'</div>';
			
			if( substr($this->request['forum_mmoo_current'], 0, 5) == 'trash' ){
				$styleCompact = ' style="display:none;"';
				$styleFull = '';
			}else{
				$styleCompact = '';
				$styleFull = ' style="display:none;"';
			}
			$this->outputMain .= '<div class="forum_mmoo-is_main"><span id="forum_mmoo_trash_compact" class="forum_mmoo-menu_button"'.$styleCompact.' onClick="jQuery(\'.forum_mmoo_trash_full\').show(); jQuery(\'#forum_mmoo_trash_compact\').hide();">TRASH</span></div>';
			$this->outputMain .= '<div class="forum_mmoo-is_main"><span class="forum_mmoo-have_sub forum_mmoo_trash_full"'.$styleFull.'onClick="jQuery(\'.forum_mmoo_trash_full\').hide(); jQuery(\'#forum_mmoo_trash_compact\').show();">TRASH</span></div>';
			$this->outputMain .= '<div class="forum_mmoo-is_sub forum_mmoo_trash_full"'.$styleFull.'>';
			$this->outputMain .= $this->getMenuButton('trash_inbox', 'INBOX', true);
			$this->outputMain .= $this->getMenuButton('trash_outbox', 'OUTBOX', true);
			$this->outputMain .= $this->getMenuButton('trash_draft', 'DRAFT', true);
			$this->outputMain .= '</div>';
			$this->outputMain .= '</div>';
			$this->outputMain .= '<div id="forum_mmoo-message_content">';
			
			if( $this->request['forum_mmoo_current'] == 'new_message' ){
				$this->outputMain .= $this->newMessage();
			}else{
				if( !empty($this->request['message_id']) ){
					$this->messageInfo = $this->objMessage->getMessage($this->request['message_id']);
				}
				$this->setMessageContent();
			}
			$this->outputMain .= '</div>';
		}
	}
	
	function getMenuButton($current, $text, $trash=false){
		if( $this->request['forum_mmoo_current'] == $current ){
			$class = 'current';
		}else{
			$class = 'forum_mmoo-menu_button';
		}
		if( $trash ){
			$class .= ' forum_mmoo_trash_full';
		}
		$return .= '<span class="'.$class.'" onClick="location.href=\''.forum_mmoo_make_content_url('message',array('forum_mmoo_current'=>$current)).'\'">';
		$return .= $text;
		$return .= '</span>';
		return $return;
	}
	
	function newMessage(){
		$return = '';
		if( $this->request['to_member_id']==null ){
			include_once(FORUM_MMOO_FUNCTIONS_DIR.'search_member.php');
			include_once(FORUM_MMOO_DATA_DIR.'data_member_info.php');
			$objMemberInfo = new forum_mmoo_data_member_info();
			$searchItems = $objMemberInfo->getData(true,true);
			if( empty($this->request['forum_mmoo_member_search']) ){
				$return .= '<span class="forum_mmoo-page_title">Search Members</span>';
				$return .= '<form name="forum_mmoo_form" method="post" action="'.forum_mmoo_make_content_url('message',array('forum_mmoo_current'=>'new_message')).'">';
				$return .= '<input type="hidden" name="forum_mmoo_member_search" value=1>';
				$return .= '<input type="checkbox" name="forum_mmoo_can_send" value=1 checked>Only those who can receive messages.';
				$return .= '<table class="forum_mmoo-member_search">';
				$return .= forum_mmoo_get_member_search_table($searchItems);
				$return .= '</table>';
				$return .= '<div align="center"><span class="forum_mmoo-psudo_button" onClick="document.forum_mmoo_form.submit();">Search</span></div>';
				$return .= '</form>';
			}else{
				include_once(FORUM_MMOO_DATA_DIR.'data_group.php');
				$objGroup = new forum_mmoo_data_group();
				$resultGroupInfo = $objGroup->getData();
				$groupInfo = array();
				$whereGroup = array();
				foreach($resultGroupInfo as $g){
					$groupInfo[$g['id']] = $g;
					if( $g['send_message'] == FORUM_MMOO_FLAG_YES ){
						$whereGroup[] = $g['id'];
					}
				}
				$whereArray = array();
				$whereArray['id'] = array( '<>' => $this->memberInfo['member_id'] );
				if( $this->request['forum_mmoo_can_send']==1 && empty($whereGroup) ){
					$foundMemberNum = 0;
				}else{
					if( $this->request['forum_mmoo_can_send']==1 ){
						$whereArray['group_id'] = array('in'=>$whereGroup);
					}
					include_once(FORUM_MMOO_DATA_DIR.'data_members.php');
					$objMembers = new forum_mmoo_data_members();
					$whereString = $objMembers->mergeWhere(forum_mmoo_get_member_search_where($searchItems, $this->request));
					$foundMemberNum = $objMembers->getMemberNumTotal($whereArray, $whereString, 'strict');
				}
				if($foundMemberNum==0){
					$return .= '<p class="forum_mmoo-alert">No member available.</p>';
				}else{
					$return .= '<strong>'.$foundMemberNum.' members found.</strong><br>';
					$p = 1;
					if( FORUM_MMOO_DASHBOARD_MEMBER_NUM < $foundMemberNum ){
						if( !empty($this->request['forum_mmoo_page']) ){
							$p = $this->request['forum_mmoo_page'];
						}
						$queryToPass = forum_mmoo_get_member_search_query($searchItems, $this->request);
						$queryToPass['forum_mmoo_current'] = 'new_message';
						$queryToPass['forum_mmoo_member_search'] = 1;
						$paginateArgs = array(
							'base' => forum_mmoo_make_content_url('message',$queryToPass).'%_%'
							, 'format' => forum_mmoo_get_paginate_format('forum_mmoo_page')
							, 'total' => ceil( $foundMemberNum / FORUM_MMOO_CONTENT_MEMBER_NUM )
							, 'current' => $p
							, 'show_all' => false
							, 'prev_next' => true
							, 'prev_text' => ' << prev '
							, 'next_text' => ' next >> '
							, 'end_size' => 3
							, 'mid_size' => 5
							, 'type' => 'plain'
						);
						$return .= '<div class="forum_mmoo-paginate_links">'.paginate_links($paginateArgs).'</div>';
					}
					$result = $objMembers->getMemberInfoForPage( $whereArray, $whereString, 'strict', $p , FORUM_MMOO_CONTENT_MEMBER_NUM);
					
					$return .= '<table class="forum_mmoo-member_found">';
					
					if( $this->request['forum_mmoo_can_send']==1 ){
						$sendWidth = 10;
					}else{
						$sendWidth = 12;
					}
					foreach($result as $row){
						$return .= '<tr>';
						$hn = forum_mmoo_excerpt($row['hn'],FORUM_MMOO_HN_SHORTEN);
						if( strlen($hn) == 0 ){
							$hn = FORUM_MMOO_HN_ANONYMOUS;
						}
						$return .= '<td>'.$hn.'</td>';
						$return .= '<td style="width:8em;"><a href="'.forum_mmoo_make_content_url('profile', array('forum_mmoo_member'=>$row['id']) ).'">>>view profile</a></td>';
						$return .= '<td style="width:'.$sendWidth.'em;">';
						
						if( $groupInfo[$row['group_id']]['send_message'] == FORUM_MMOO_FLAG_YES ){
							$return .= '<a href="'.forum_mmoo_make_content_url('message',array('forum_mmoo_current'=>'new_message', 'to_member_id'=>$row['id']) ).'">>>send message</a>';
						}else{
							$return .= 'This member is not allowed to receive messages.';
						}
						$return .= '</td>';
						$return .= '</tr>';
					}
					$return .= '</table>';
				}
				$return .= '<a class="forum_mmoo-psudo_button" href="'.forum_mmoo_make_content_url('message',array('forum_mmoo_current'=>'new_message') ).'">Search Again</a>';
			}
		}else{
			if( empty($this->request['message_action']) ){
				include_once(FORUM_MMOO_FUNCTIONS_DIR.'editor.php');
				$return .= '<span class="forum_mmoo-page_title">New Message</span>';
				$return .= '<div class="forum_mmoo-new_message">';
				$return .= '<span class="forum_mmoo-label_message_to">To : </span>'.$this->getMemberLink($this->request['to_member_id']);
				$return .= '<form name="forum_mmoo_form" method=post action="'.forum_mmoo_make_content_url('message').'">';
				$return .= '<input type="hidden" name="forum_mmoo_current" value="new_message">';
				$return .= '<input type="hidden" name="to_member_id" value="'.$this->request['to_member_id'].'">';
				$return .= '<input type="hidden" id="message_action" name="message_action" value="">';
				$return .= '<span class="forum_mmoo-label_message_title">Title : </span><input type="text" class="forum_mmoo-message_title" name="message_title">';
				$return .= forum_mmoo_editor('', 'message_content');
				$return .= '<div class="forum_mmoo-new_message_buttons">';
				$return .= '<span class="forum_mmoo-psudo_button" onClick="jQuery(\'#message_action\').val(\'draft\'); document.forum_mmoo_form.submit();">Save As Draft</span>';
				$return .= '&nbsp;&nbsp;&nbsp;&nbsp;';
				$return .= '<span class="forum_mmoo-psudo_button" onClick="jQuery(\'#message_action\').val(\'outbox\'); document.forum_mmoo_form.submit();">Send NOW!!</span>';
				$return .= '</div>';
				$return .= '</form>';
				$return .= '</div>';
			}else{
				if( $this->objMessage->newMessage(
					$this->memberInfo['member_id']
					, $this->request['to_member_id']
					, wp_kses_post($this->request['message_title'])
					, wpautop(wp_kses_post($this->request['message_content']))
					, $this->request['message_action']
				)){
					$return .= '<div id="forum_mmoo-success_message">';
					if( $this->request['message_action'] == 'draft' ){
						$return .= 'Massage saved!';
					}else{
						$return .= 'Message sent!';
						$this->sendNotify($this->request['to_member_id']);
					}
					$return .= '</div>';
				}else{
					$return .= '<div id="forum_mmoo-error_message">';
					$return .= 'Failed to ';
					if( $this->request['message_action'] == 'draft' ){
						$return .= 'save';
					}else{
						$return .= 'send';
					}
					$return .= 'the message. '.FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE.'</div>';
				}
			}
		}
		return $return;
	}
		
	function setMessageContent(){
		$invalid = false;
		if( !empty($this->messageInfo) ){
			switch( $this->request['forum_mmoo_current'] ){
				case 'inbox':
				case 'trash_inbox':
					if( $this->messageInfo['to_member'] != $this->memberInfo['member_id'] ){
						$invalid = true;
					}
				break;
			
				case 'outbox':
				case 'draft':
				case 'trash_outbox':
				case 'trash_draft':
					if( $this->messageInfo['from_member'] != $this->memberInfo['member_id'] ){
						$invalid = true;
					}
				break;
				
				default:
					$invalid = true;
				break;
			}
		}
		
		if( $invalid || empty($this->messageInfo) ){
			$this->showList();
		}else{
			switch( $this->request['forum_mmoo_current'] ){
				case 'inbox':
					if( $this->request['message_action']=='trash' ){
						if( $this->objMessage->changeToStatus( $this->messageInfo['id'], 'trash_'.$this->messageInfo['to_status'] ) ){
							$this->outputMain .= '<div id="forum_mmoo-success_message">Moved to the TRASH.</div>';
						}else{
							$this->outputMain .= '<div id="forum_mmoo-error_message">Failed to move to the TRASH. '.FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE.'</div>';
						}
						$this->showList();
					}elseif( $this->request['message_action']=='delete' ){
						if( $this->objMessage->changeToStatus( $this->messageInfo['id'], 'never_to_be_seen' ) ){
							$this->outputMain .= '<div id="forum_mmoo-success_message">Message deleted.</div>';
						}else{
							$this->outputMain .= '<div id="forum_mmoo-error_message">Failed to delete the message. '.FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE.'</div>';
						}
						$this->showList();
					}else{
						if( $this->messageInfo['to_status']=='new' ){
							$this->objMessage->changeToStatus($this->messageInfo['id'], 'read');
						}
						$this->showMessageDetail();
					}
				break;
				
				case 'outbox':
					if( $this->request['message_action']=='trash' ){
						if( $this->objMessage->changeFromStatus( $this->messageInfo['id'], 'trash_outbox' ) ){
							$this->outputMain .= '<div id="forum_mmoo-success_message">Moved to the TRASH.</div>';
						}else{
							$this->outputMain .= '<div id="forum_mmoo-error_message">Failed to move to the TRASH. '.FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE.'</div>';
						}
						$this->showList();
					}elseif( $this->request['message_action']=='delete' ){
						if( $this->objMessage->changeFromStatus( $this->messageInfo['id'], 'never_to_be_seen' ) ){
							$this->outputMain .= '<div id="forum_mmoo-success_message">Message deleted.</div>';
						}else{
							$this->outputMain .= '<div id="forum_mmoo-error_message">Failed to delete the message. '.FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE.'</div>';
						}
						$this->showList();
					}else{
						$this->showMessageDetail();
					}
				break;
				
				case 'draft':
					if( $this->request['message_action']=='trash' ){
						if( $this->objMessage->changeFromStatus( $this->messageInfo['id'], 'trash_draft' ) ){
							$this->outputMain .= '<div id="forum_mmoo-success_message">Moved to the TRASH.</div>';
						}else{
							$this->outputMain .= '<div id="forum_mmoo-error_message">Failed to move to the TRASH. '.FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE.'</div>';
						}
						$this->showList();
					}elseif( $this->request['message_action']=='delete' ){
						if( $this->objMessage->changeFromStatus( $this->messageInfo['id'], 'never_to_be_seen' ) ){
							$this->outputMain .= '<div id="forum_mmoo-success_message">Message deleted.</div>';
						}else{
							$this->outputMain .= '<div id="forum_mmoo-error_message">Failed to delete the message. '.FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE.'</div>';
						}
						$this->showList();
					}elseif( $this->request['message_action']=='outbox' ){
						if( !$this->objMessage->editMessage($this->messageInfo['id'], wp_kses_post($this->request['message_title']), wpautop(wp_kses_post($this->request['message_content']))) ){
							$this->outputMain .= '<div id="forum_mmoo-error_message">Failed to send the message. '.FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE.'</div>';
							$this->showEdit();
						}else{
							if( $this->objMessage->changeFromStatus( $this->messageInfo['id'], 'outbox' ) ){
								$this->outputMain .= '<div id="forum_mmoo-success_message">Message sent!</div>';
								$this->sendNotify($this->messageInfo['to_member']);
							}else{
								$this->outputMain .= '<div id="forum_mmoo-error_message">Failed to send the message. '.FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE.'</div>';
							}
							$this->showList();
						}
					}elseif( $this->request['message_action']=='draft' ){
						if( $this->objMessage->editMessage($this->messageInfo['id'], wp_kses_post($this->request['message_title']), wpautop(wp_kses_post($this->request['message_content']))) ){
							$this->outputMain .= '<div id="forum_mmoo-success_message">Edited message saved.</div>';
							$this->showList();
						}else{
							$this->outputMain .= '<div id="forum_mmoo-error_message">Failed to save the edited message. '.FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE.'</div>';
							$this->showEdit();
						}
					}elseif( $this->request['message_action']=='send_immediate' ){
						if( $this->objMessage->changeFromStatus( $this->messageInfo['id'], 'outbox' ) ){
							$this->outputMain .= '<div id="forum_mmoo-success_message">Message sent!</div>';
							$this->sendNotify($this->messageInfo['to_member']);
						}else{
							$this->outputMain .= '<div id="forum_mmoo-error_message">Failed to send the message. '.FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE.'</div>';
						}
						$this->showList();
					}else{
						$this->showEdit();
					}
				break;
				
				case 'trash_inbox':
					if( $this->request['message_action']=='recover' ){
						if( $this->objMessage->changeToStatus( $this->messageInfo['id'], substr($this->messageInfo['to_status'],6) ) ){
							$this->outputMain .= '<div id="forum_mmoo-success_message">Moved back to the INBOX.</div>';
						}else{
							$this->outputMain .= '<div id="forum_mmoo-error_message">Failed to move back to the INBOX. '.FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE.'</div>';
						}
						$this->showList();
					}elseif( $this->request['message_action']=='delete' ){
						if( $this->objMessage->changeToStatus( $this->messageInfo['id'], 'never_to_be_seen' ) ){
							$this->outputMain .= '<div id="forum_mmoo-success_message">Message deleted.</div>';
						}else{
							$this->outputMain .= '<div id="forum_mmoo-error_message">Failed to delete the message. '.FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE.'</div>';
						}
						$this->showList();
					}else{
						if( $this->messageInfo['to_status']=='trash_new' ){
							$this->objMessage->changeToStatus($this->messageInfo['id'], 'trash_read');
						}
						$this->showMessageDetail();
					}
				break;
				
				case 'trash_outbox':
					if( $this->request['message_action']=='recover' ){
						if( $this->objMessage->changeFromStatus( $this->messageInfo['id'], 'outbox' ) ){
							$this->outputMain .= '<div id="forum_mmoo-success_message">Moved back to the OUTBOX.</div>';
						}else{
							$this->outputMain .= '<div id="forum_mmoo-error_message">Failed to move back to the OUTBOX. '.FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE.'</div>';
						}
						$this->showList();
					}elseif( $this->request['message_action']=='delete' ){
						if( $this->objMessage->changeFromStatus( $this->messageInfo['id'], 'never_to_be_seen' ) ){
							$this->outputMain .= '<div id="forum_mmoo-success_message">Message deleted.</div>';
						}else{
							$this->outputMain .= '<div id="forum_mmoo-error_message">Failed to delete the message. '.FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE.'</div>';
						}
						$this->showList();
					}else{
						$this->showMessageDetail();
					}
				break;
				
				case 'trash_draft':
					if( $this->request['message_action']=='recover' ){
						if( $this->objMessage->changeFromStatus( $this->messageInfo['id'], 'draft' ) ){
							$this->outputMain .= '<div id="forum_mmoo-success_message">Moved back to the DRAFT.</div>';
						}else{
							$this->outputMain .= '<div id="forum_mmoo-error_message">Failed to move back to the DRAFT. '.FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE.'</div>';
						}
						$this->showList();
					}elseif( $this->request['message_action']=='delete' ){
						if( $this->objMessage->changeFromStatus( $this->messageInfo['id'], 'never_to_be_seen' ) ){
							$this->outputMain .= '<div id="forum_mmoo-success_message">Message deleted.</div>';
						}else{
							$this->outputMain .= '<div id="forum_mmoo-error_message">Failed to delete the message. '.FORUM_MMOO_UNEXPECTED_ERROR_MESSAGE.'</div>';
						}
						$this->showList();
					}else{
						$this->showMessageDetail();
					}
				break;
				
				default:
					$this->showMessageDetail();
				break;
			}
		}
	}
	
	function showList(){
		$messageNum = $this->objMessage->getMessageNum($this->memberInfo['member_id'], $this->request['forum_mmoo_current']);
		if( $messageNum == 0 ){
			$this->outputMain .= '<p class="forum_mmoo-comment">No messages yet</p>';
		}else{
			$p = 1;
			if( !empty($this->request['forum_mmoo_page']) ){
				$p = $this->request['forum_mmoo_page'];
			}
			if( $messageNum > FORUM_MMOO_MESSAGE_NUM ){
				$paginateArgs = array(
					'base' => forum_mmoo_make_content_url('message',array('forum_mmoo_current'=>$this->request['forum_mmoo_current'])).'%_%'
					, 'format' => forum_mmoo_get_paginate_format('forum_mmoo_page')
					, 'total' => ceil( $messageNum / FORUM_MMOO_MESSAGE_NUM )
					, 'current' => $p
					, 'show_all' => false
					, 'prev_next' => true
					, 'prev_text' => ' << prev '
					, 'next_text' => ' next >> '
					, 'end_size' => 3
					, 'mid_size' => 5
					, 'type' => 'plain'
				);
				$this->outputMain .= '<div class="forum_mmoo-paginate_links">'.paginate_links($paginateArgs).'</div>';
			}
			$messageList = $this->objMessage->getMessageList($this->memberInfo['member_id'], $this->request['forum_mmoo_current'], $p, FORUM_MMOO_MESSAGE_NUM);
			$arrTableItems = $this->getTableItems();
			$changeBoxButtons = $this->getChangeBoxButtons();
			$hnWidth = FORUM_MMOO_HN_SHORTEN + 1;
			$this->outputMain .= '<table class="forum_mmoo-message_list">';
			$this->outputMain .= '<tr>';
			$this->outputMain .= '<th style="width:'.$hnWidth.'em;">'.$arrTableItems['hnLabel'].'</th>';
			$this->outputMain .= '<th style="width:7em;">'.$arrTableItems['dateLabel'].'</th>';
			$this->outputMain .= '<th>MESSAGE</th>';
			$this->outputMain .= '<th style="width:'.$arrTableItems['buttonWidth'].'px; text-align:center;">ACTION</th>';
			$this->outputMain .= '</tr>';
			
			foreach($messageList as $message){
				$this->outputMain .= '<tr>';
				$this->outputMain .= '<td>'.$this->getMemberLink($message[$arrTableItems['hnCol']]).'</td>';
				$this->outputMain .= '<td style="font-size:0.7em;">'.forum_mmoo_convert_datetime_compact($message[$arrTableItems['dateCol']]).'</td>';
				$this->outputMain .= '<td>';
				$this->outputMain .= '<a href="'.forum_mmoo_make_content_url('message',array('forum_mmoo_current'=>$this->request['forum_mmoo_current'],'message_id'=>$message['id'])).'">';
				$messageTitle = forum_mmoo_excerpt($message['title'],FORUM_MMOO_MESSAGE_SHORTEN);
				if( strlen($messageTitle)==0 ){
					$messageTitle = 'No Title';
				}
				$this->outputMain .= $messageTitle;
				$this->outputMain .= '</a>';
				if( 
					( $this->request['forum_mmoo_current']=='inbox' && $message['to_status']=='new' )
					||
					( $this->request['forum_mmoo_current']=='trash_inbox' && $message['to_status']=='trash_new' )
				){
					$this->outputMain .= '<img src="'.FORUM_MMOO_FILE_URL.'/image/new.jpg" alt="new">';
				}
				$this->outputMain .= '</td>';
				$this->outputMain .= '<td style="text-align:center;">';
				
				foreach($changeBoxButtons as $button){
					$buttonId = 'forum_mmoo-'.$button['image'].'_button_'.$message['id'];
					$hintId = 'forum_mmoo-'.$button['image'].'_hint_'.$message['id'];
					$leftDiff = strlen($button['text']) * -3.5;
					
					$this->outputMain .= '<span class="forum_mmoo-message_icon">';
					$this->outputMain .= '<img src="'.FORUM_MMOO_FILE_URL.'/image/'.$button['image'].'.jpg'.'"';
					$this->outputMain .= ' id="'.$buttonId.'"';
					$this->outputMain .= ' class="mmoo_popup_open_button" ';
					$this->outputMain .= ' alt="'.$button['text'].'"';
					$this->outputMain .= ' onClick="location.href=\''.forum_mmoo_make_content_url('message',array('forum_mmoo_current'=>$this->request['forum_mmoo_current'],'message_id'=>$message['id'],'message_action'=>$button['action'])).'\'"';
					$this->outputMain .= '>';
					$this->outputMain .= '</span>';
					$this->outputMain .= '<span id="'.$hintId.'" class="forum_mmoo-hint" style="display:none;">'.$button['text'].'</span>';
					$this->outputMain .= '<script type="text/javascript">jQuery("#'.$buttonId.'").mouseover(function(){mmoo_popOpenCloseToButton("'.$hintId.'", "'.$buttonId.'", -32, '.$leftDiff.')});</script>';
					$this->outputMain .= '<script type="text/javascript">jQuery("#'.$buttonId.'").mouseout(function(){jQuery("#'.$hintId.'").hide();});</script>';
				}
				$this->outputMain .= '</td>';
				$this->outputMain .= '</tr>';
			}
			
			$this->outputMain .= '</table>';
		}
	}
	
	function getChangeBoxButtons(){
		switch( $this->request['forum_mmoo_current'] ){
			case 'inbox':
				return array(
					array('action'=>'trash', 'image'=>'message_trash', 'text'=>'to TRASH')
					, array('action'=>'delete', 'image'=>'message_delete', 'text'=>"completely delete it! (But remain in the sender's outbox.)")
				);
			case 'outbox':
				return array(
					array('action'=>'trash', 'image'=>'message_trash', 'text'=>'to TRASH')
					, array('action'=>'delete', 'image'=>'message_delete', 'text'=>"completely delete it! (But remain in the receipient's inbox)")
				);
			
			case 'draft':
				return array(
					array('action'=>'', 'image'=>'message_edit', 'text'=>'Edit')
					, array('action'=>'send_immediate','image'=>'message_send', 'text'=>'Send NOW')
					, array('action'=>'trash', 'image'=>'message_trash', 'text'=>'to TRASH')
					, array('action'=>'delete', 'image'=>'message_delete', 'text'=>'completely delete it!')
					
				);
			
			case 'trash_inbox':
				return array(
					array('action'=>'recover', 'image'=>'message_trash_recover', 'text'=>'restore')
					, array('action'=>'delete', 'image'=>'message_delete', 'text'=>"completely delete it! (But remain in the sender's outbox.)")
				);
			
			case 'trash_outbox':
				return array(
					array('action'=>'recover', 'image'=>'message_trash_recover', 'text'=>'restore')
					, array('action'=>'delete', 'image'=>'message_delete', 'text'=>"completely delete it! (But remain in the receipient's inbox)")
				);
			
			case 'trash_draft':
				return array(
					array('action'=>'recover', 'image'=>'message_trash_recover', 'text'=>'restore')
					, array('action'=>'delete', 'image'=>'message_delete', 'text'=>'completely delete it!')
				);
			
			default:
				return array();
		}
	}
	
	function getTableItems(){
		switch( $this->request['forum_mmoo_current'] ){
			case 'inbox':
				return array(
					'hnLabel' => 'From'
					, 'dateLabel' => 'sent at'
					, 'hnCol' => 'from_member'
					, 'dateCol' => 'sent_at'
					, 'buttonWidth' => 40
				);
			
			case 'outbox':
				return array(
					'hnLabel' => 'To'
					, 'dateLabel' => 'sent at'
					, 'hnCol' => 'to_member'
					, 'dateCol' => 'sent_at'
					, 'buttonWidth' => 40
				);
			
			case 'draft':
				return array(
					'hnLabel' => 'To'
					, 'dateLabel' => 'written at'
					, 'hnCol' => 'to_member'
					, 'dateCol' => 'updated_time'
					, 'buttonWidth' => 80
				);
			
			case 'trash_inbox':
				return array(
					'hnLabel' => 'To'
					, 'dateLabel' => 'sent at'
					, 'hnCol' => 'from_member'
					, 'dateCol' => 'sent_at'
					, 'buttonWidth' => 40
				);
			
			case 'trash_outbox':
				return array(
					'hnLabel' => 'To'
					, 'dateLabel' => 'sent at'
					, 'hnCol' => 'to_member'
					, 'dateCol' => 'sent_at'
					, 'buttonWidth' => 40
				);
			
			case 'trash_draft':
				return array(
					'hnLabel' => 'To'
					, 'dateLabel' => 'written at'
					, 'hnCol' => 'to_member'
					, 'dateCol' => 'updated_time'
					, 'buttonWidth' => 40
				);
			
			default:
				return array();
		}
	}
	
	function showMessageDetail(){
		$tableItems = $this->getTableItems();
		
		include_once(FORUM_MMOO_DATA_DIR.'data_members.php');
		$objMembers = new forum_mmoo_data_members();
		$hnInfo = $objMembers->getMemberInfoById($this->messageInfo[$tableItems['hnCol']]);
		
		$changeBoxButtons = $this->getChangeBoxButtons();
		foreach($changeBoxButtons as $button){
			$this->outputMain .= '<a class="forum_mmoo-psudo_button" style="margin: 1em 1em 1em 0em;" href="';
			$this->outputMain .= forum_mmoo_make_content_url('message',array('forum_mmoo_current'=>$this->request['forum_mmoo_current'],'message_id'=>$this->messageInfo['id'],'message_action'=>$button['action'])).'">';
			$this->outputMain .= $button['text'];
			$this->outputMain .= '</a>';
		}
		
		$this->outputMain .= '<table class="forum_mmoo-message_detail">';
		$this->outputMain .= '<tr>';
		$this->outputMain .= '<th>'.$tableItems['hnLabel'].'</th>';
		$this->outputMain .= '<td>';
		$this->outputMain .= '<a href="'.forum_mmoo_make_content_url('profile', array('forum_mmoo_member'=>$this->messageInfo[$tableItems['hnCol']]) ).'">';
		$this->outputMain .= $hnInfo['hn'];
		$this->outputMain .= '</a>';
		$this->outputMain .= '</td>';
		$this->outputMain .= '<tr>';
		$this->outputMain .= '<th>'.$tableItems['dateLabel'].'</th>';
		$this->outputMain .= '<td>'.forum_mmoo_convert_datetime($this->messageInfo[$tableItems['dateCol']]).'</td>';
		$this->outputMain .= '</tr>';
		$this->outputMain .= '<tr>';
		$this->outputMain .= '<th>TITLE</th>';
		$this->outputMain .= '<td>'.$this->messageInfo['title'].'</td>';
		$this->outputMain .= '</tr>';
		$this->outputMain .= '<tr>';
		$this->outputMain .= '<td class="content" colspan="2">'.$this->messageInfo['message'].'</td>';
		$this->outputMain .= '</tr>';
		$this->outputMain .= '</table>';
	}
	
	function showEdit(){
		include_once(FORUM_MMOO_FUNCTIONS_DIR.'editor.php');
		$this->outputMain .= '<span class="forum_mmoo-page_title">Edit Message</span>';
		$this->outputMain .= '<div class="forum_mmoo-new_message">';
		$this->outputMain .= '<span class="forum_mmoo-label_message_to">To : </span>'.$this->getMemberLink($this->messageInfo['to_member']);
		$this->outputMain .= '<form name="forum_mmoo_form" method=post action="'.forum_mmoo_make_content_url('message').'">';
		$this->outputMain .= '<input type="hidden" name="forum_mmoo_current" value="'.$this->request['forum_mmoo_current'].'">';
		$this->outputMain .= '<input type="hidden" name="message_id" value="'.$this->messageInfo['id'].'">';
		$this->outputMain .= '<input type="hidden" id="message_action" name="message_action" value="">';
		$this->outputMain .= '<span class="forum_mmoo-label_message_title">TITLE : </span><input type="text" class="forum_mmoo-message_title" name="message_title" value="'.$this->messageInfo['title'].'">';
		$this->outputMain .= forum_mmoo_editor($this->messageInfo['message'], 'message_content');
		$this->outputMain .= '<div class="forum_mmoo-new_message_buttons">';
		$this->outputMain .= '<span class="forum_mmoo-psudo_button" onClick="jQuery(\'#message_action\').val(\'draft\'); document.forum_mmoo_form.submit();">Save As Draft</span>';
		$this->outputMain .= '&nbsp;&nbsp;&nbsp;&nbsp;';
		$this->outputMain .= '<span class="forum_mmoo-psudo_button" onClick="jQuery(\'#message_action\').val(\'outbox\'); document.forum_mmoo_form.submit();">Send NOW</span>';
		$this->outputMain .= '</div>';
		$this->outputMain .= '</form>';
		$this->outputMain .= '</div>';
	}
		
	function sendNotify($toMemberId){
		include_once(FORUM_MMOO_DATA_DIR.'data_members.php');
		$objMembers = new forum_mmoo_data_members();
		$toMemberInfo = $objMembers->getMemberInfoById($toMemberId);
		if( $toMemberInfo['message_notify']==FORUM_MMOO_FLAG_YES ){
			include_once(FORUM_MMOO_DATA_DIR.'data_explanation.php');
			$objExplanation = new forum_mmoo_data_explanation();
			$mailData = $objExplanation->getData('notify_message');
			
			include_once(FORUM_MMOO_FUNCTIONS_DIR.'mail.php');
			$mailContent = forum_mmoo_replace_mail_tag($mailData['content'],array('member_id'=>$toMemberId));
			forum_mmoo_mail($decodedInput['insertRow']['mail'], $mailData['title'], $mailContent);
		}
	}
}
?>