<?php
include_once(FORUM_MMOO_FUNCTIONS_DIR.'search_string.php');
class forum_mmoo_content_posts extends forum_mmoo_content{
	var $topicId;
	var $page;
	var $sortOrder;
	var $rawSearch;
	var $escapedSearch;
	var $arrSearch;
	
	var $objTopics;
	var $objThread;
	
	var $topicInfo;
	var $generalInfo;
	var $allPostInfo;
	var $cntReply;
	var $perTopicAtCeiling;
	var $notifyPosts;
	
	function __construct($request=array()){
		parent::__construct($request);
		unset($request['act']);
		$this->outputSocialButtonsUrl = forum_mmoo_make_content_url('posts', $request);
	}
	
	function setBackPage(){
		$option = array(
			'forum_mmoo_topic' => $this->topicId
			, 'forum_mmoo_sort' => $this->sortOrder
			, 'forum_mmoo_page' => $this->page
			, 'forum_mmoo_search' => $this->escapedSearch
		);
		
		$backPage = array(
			'act' => 'posts'
			, 'option' => $option
			, 'text' => 'Topic : "'.forum_mmoo_excerpt($this->topicInfo['title'],FORUM_MMOO_TOPIC_SHORTEN).'"'
		);
		forum_mmoo_set_session( 'backPage', $backPage );
	}
	
	function setOutputMain(){
		$this->topicId = $this->request['forum_mmoo_topic'];
		
		include_once(FORUM_MMOO_DATA_DIR.'data_topics.php');
		$this->objTopics = new forum_mmoo_data_topics();
		$this->topicInfo = $this->objTopics->getTopicInfo($this->topicId);
		
		include_once(FORUM_MMOO_DATA_DIR.'data_thread.php');
		$this->objThread = new forum_mmoo_data_thread( $this->topicId );
		
		include_once(FORUM_MMOO_DATA_DIR.'data_general.php');
		$objGeneral = new forum_mmoo_data_general();
		$this->generalInfo = $objGeneral->getData();
		
		if( !empty($this->request['forum_mmoo_sort']) ){
			$this->sortOrder = $this->request['forum_mmoo_sort'];
		}else{
			$this->sortOrder = $this->generalInfo['sort_post'];
		}
		
		if( !empty($this->request['forum_mmoo_post']) ){
			$this->page = $this->objThread->getPageForPost($this->request['forum_mmoo_post'], $this->generalInfo['per_page'], $this->sortOrder);
		}elseif( !empty($this->request['forum_mmoo_page']) ){
			$this->page = $this->request['forum_mmoo_page'];
		}else{
			$this->page = 1;
		}
		
		if( strlen($this->request['forum_mmoo_search'])==0 ){
			$this->rawSearch = '';
			$this->escapedSearch = '';
			$this->arrSearch = array();
		}else{
			$this->rawSearch = $this->request['forum_mmoo_search'];
			$this->escapedSearch = forum_mmoo_search_string_escape($this->request['forum_mmoo_search']);
			$this->arrSearch = forum_mmoo_search_string_into_array($this->request['forum_mmoo_search']);
		}
		
		if( $this->memberInfo['read_only'] == FORUM_MMOO_FLAG_NO ){
			$this->outputMain .= FORUM_MMOO_MUST_LOGIN_MESSAGE.' to view posts';
		}else{
			$cookieData = forum_mmoo_get_cookie();
			$seen = $cookieData['seen'];
			$seen[$this->memberInfo['member_id']][$this->topicId] = $this->objTopics->getNow();
			forum_mmoo_set_cookie('seen', $seen );
			
			if( $this->generalInfo['per_topic'] == FORUM_MMOO_FLAG_INFINIT ){
				$this->perTopicAtCeiling = false;
				$this->cntReply = false;
			}else{
				if( $this->generalInfo['per_topic_cnt_reply'] == FORUM_MMOO_FLAG_YES ){
					$this->cntReply = true;
				}else{
					$this->cntReply = false;
				}
				$currentPostNum = $this->objThread->getPostNum($this->cntReply);
				if( $currentPostNum < $this->generalInfo['per_topic'] ){
					$this->perTopicAtCeiling = false;
				}else{
					$this->perTopicAtCeiling = true;
				}
			}
			
			if( $this->memberInfo['notify_own']==FORUM_MMOO_FLAG_YES || $this->memberInfo['notify_other']==FORUM_MMOO_FLAG_YES ){
				include_once(FORUM_MMOO_DATA_DIR.'data_notify_reply.php');
				$objNotifyReply = new forum_mmoo_data_notify_reply();
				$this->notifyPosts = $objNotifyReply->getDataForMemberTopicSpecific($this->memberInfo['member_id'], $this->topicId);
			}
			
			if( strlen($this->rawSearch) == 0 ){
				$this->outputMain .= '<div class="forum_mmoo-page_title">Posts in "'.$this->topicInfo['title'].'"</div>';
			}else{
				$this->outputMain .= '<div class="forum_mmoo-page_title">Posts found in "'.$this->topicInfo['title'].'"</div>';
			}
			
			$mainPostNum = $this->objThread->getPostNum( false , $this->rawSearch );
			if( $mainPostNum > 0 ){
				$this->allPostInfo = $this->objThread->getData( $this->generalInfo['per_page'], $this->page, $this->sortOrder, $this->rawSearch );
				$tree = $this->getTree($this->allPostInfo);
				if( $this->sortOrder == 'desc' ){
					$tree = $this->sortTree($tree);
				}
				
				$queryToPass = array(
					'forum_mmoo_topic' => $this->topicId
					, 'forum_mmoo_search' => $this->escapedSearch
					, 'forum_mmoo_sort' => $this->sortOrder
				);
				$paginateArgs = array(
					'base' => forum_mmoo_make_content_url('posts',$queryToPass).'%_%'
					, 'format' => forum_mmoo_get_paginate_format('forum_mmoo_page')
					, 'total' => ceil( $mainPostNum / $this->generalInfo['per_page'] )
					, 'current' => $this->page
					, 'show_all' => false
					, 'prev_next' => true
					, 'prev_text' => ' << prev '
					, 'next_text' => ' next >> '
					, 'end_size' => 3
					, 'mid_size' => 5
					, 'type' => 'plain'
				);
				
				$this->outputMain .= '<div class="forum_mmoo-post_search_box">';
				$this->outputMain .= '<form name="forum_mmoo_form" method=post action="'.forum_mmoo_make_content_url('posts').'">';
				$this->outputMain .= '<input type="hidden" name="forum_mmoo_topic" value="'.$this->topicId.'">';
				$this->outputMain .= '<input type="hidden" name="forum_mmoo_sort" value="'.$this->sortOrder.'">';
				$this->outputMain .= '<span class="forum_mmoo-label_post_search">Search Posts in this Topoic : </span>';
				$this->outputMain .= '<input type="text" class="forum_mmoo-post_search" name="forum_mmoo_search">';
				$this->outputMain .= '<span class="forum_mmoo-psudo_button" onClick="document.forum_mmoo_form.submit();">Search</span>';
				$this->outputMain .= '</form>';
				$this->outputMain .= '</div>';
				
				$this->outputMain .= '<div class="forum_mmoo-post_sort_box">';
				$this->outputMain .= '<select onChange="location.href=this.options[this.selectedIndex].value">';
				$selected = $this->sortOrder=='desc' ? ' selected' : '';
				$this->outputMain .= '<option value="'.forum_mmoo_make_content_url('posts',array('forum_mmoo_topic' => $this->topicId, 'forum_mmoo_sort'=>'desc')).'"'.$selected.'>&nbsp;New to Old&nbsp;</option>';
				$selected = $this->sortOrder=='asc' ? ' selected' : '';
				$this->outputMain .= '<option value="'.forum_mmoo_make_content_url('posts',array('forum_mmoo_topic' => $this->topicId, 'forum_mmoo_sort'=>'asc')).'"'.$selected.'>&nbsp;Old to New&nbsp;</option>';
				$this->outputMain .= '</select>';
				$this->outputMain .= '</div>';
			}
			
			$this->outputMain .= '<div class="forum_mmoo-post_new_box">';
			if( $this->memberInfo['post'] == FORUM_MMOO_FLAG_NO ){
				$this->outputMain .= '<span class="forum_mmoo-alert">'.FORUM_MMOO_MUST_LOGIN_MESSAGE.' to post</span>';
			}else{
				if( $this->perTopicAtCeiling ){
					$this->outputMain .= '<span class="forum_mmoo-comment">This topic can have no more posts.</span>';
				}else{
					$this->outputMain .= '<a class="forum_mmoo-psudo_button" href="'.forum_mmoo_make_content_url('edit_post',array('forum_mmoo_topic'=>$this->topicId)).'">New Post</a>';
				}
			}
			$this->outputMain .= '</div>';
			
			if( $mainPostNum > 0 ){
				$this->outputMain .= '<div class="forum_mmoo-paginate_links">'.paginate_links($paginateArgs).'</div>';
				$this->outputMain .= $this->getFullForm($tree);
				$this->outputMain .= '<div class="forum_mmoo-paginate_links">'.paginate_links($paginateArgs).'</div>';
			}else{
				if( strlen($this->request['forum_mmoo_search']) == 0 ){
					$this->outputMain .= '<div class="forum_mmoo-post_empty">No posts in this topic yet.</div>';
				}else{
					$this->outputMain .= '<div class="forum_mmoo-post_empty">No posts found in this topic.</div>';
				}
			}
		}
	}
	
	function getTree(){
		if( empty($this->allPostInfo) ){
			return array();
		}
		
		$tree = array();
		foreach($this->allPostInfo as $row){
			if( empty($tree[$row['depth']][$row['id']]) ){
				$tree[$row['depth']][$row['id']] = array();
			}
			if( !empty($row['depth']) ){
				$tree[$row['depth']-1][$row['direct_parent']][$row['id']] = array();
			}
		}
		
		for($i=count($tree)-2; $i>-1; $i--){
			foreach($tree[$i] as $parent => $children){
				foreach($children as $child => $dummyArray){
					$tree[$i][$parent][$child] = $tree[$i+1][$child];
				}
			}
			unset($tree[$i+1]);
		}
		
		return $tree[0];
	}
	
	function sortTree($tree){
		krsort($tree);
		if( !empty($tree) ){
			foreach($tree as $id => $branch){
				$tree[$id] = $this->sortTree($branch);
			}
		}
		return $tree;
	}
	
	function makeButton($postId, $button, $hintText, $onClickHref='', $imageName='', $ng=false){
		$buttonId = 'forum_mmoo-'.$button.'_button_'.$postId;
		$hintId = 'forum_mmoo-'.$button.'_hint_'.$postId;
		$imageFile = empty($imageName) ? FORUM_MMOO_FILE_URL.'/image/'.$button.'.jpg' : FORUM_MMOO_FILE_URL.'/image/'.$imageName.'.jpg';
		$onClick = empty($onClickHref) ? '' : 'onClick="location.href=\''.$onClickHref.'\'"';
		$leftDiff = strlen($hintText) * -5;
		$hintClass = $ng ? 'forum_mmoo-hint_ng' : 'forum_mmoo-hint';
		
		$return = '<span class="forum_mmoo-post_icon">';
		$return .= '<img src="'.$imageFile.'" id="'.$buttonId.'" alt="'.$hintText.'" class="mmoo_popup_open_button" '.$onClick.'>';
		$return .= '</span>';
		$return .= '<span id="'.$hintId.'" class="'.$hintClass.'" style="display:none;">'.$hintText.'</span>';
		$return .= '<script type="text/javascript">jQuery("#'.$buttonId.'").mouseover(function(){mmoo_popOpenCloseToButton("'.$hintId.'", "'.$buttonId.'", -30, '.$leftDiff.')});</script>';
		$return .= '<script type="text/javascript">jQuery("#'.$buttonId.'").mouseout(function(){jQuery("#'.$hintId.'").hide();});</script>';
		return $return;
	}
	
	function getPostDiv($postId, $childNum){
		$return = '';
		$postInfo = $this->allPostInfo[$postId];
		
		$option = array('forum_mmoo_topic' => $this->topicId);
		
		$canReply = false;
		if( $this->generalInfo['max_depth']==FORUM_MMOO_FLAG_ZERO || $this->generalInfo['max_reply']==FORUM_MMOO_FLAG_ZERO ){
			$replyButton = '';
		}elseif( $this->perTopicAtCeiling && $this->cntReply ){
			$replyButton = $this->makeButton($postId, 'reply', "This topic can have no more posts, and you can't reply to this post.", "", 'reply_cant', true);
		}elseif( $this->generalInfo['max_depth']!=FORUM_MMOO_FLAG_INFINIT && $this->generalInfo['max_depth']<=$postInfo['depth'] ){
			$replyButton = $this->makeButton($postId, 'reply', "You can't reply deaper into this post.", "", 'reply_cant', true);
		}elseif( $this->generalInfo['max_reply']!=FORUM_MMOO_FLAG_INFINIT && $this->generalInfo['max_reply']<=$childNum ){
			$replyButton = $this->makeButton($postId, 'reply', "This post can have no more replies.", "", 'reply_cant', true);
		}else{
			$replyOption = $option;
			$replyOption['forum_mmoo_parent'] = $postInfo['id'];
			$replyHref = forum_mmoo_make_content_url( 'edit_post' , $replyOption );
			$replyButton = $this->makeButton($postId, 'reply', 'Reply To This Post', $replyHref);
			$canReply = true;
		}
		if( $this->memberInfo['post']==FORUM_MMOO_FLAG_NO ){
			$replyButton = '';
		}
		
		if( $this->memberInfo['edit_other']==FORUM_MMOO_FLAG_YES ){
			$canEdit = true;
		}elseif( $this->memberInfo['edit_own']==FORUM_MMOO_FLAG_YES && $postInfo['posted_by']==$this->memberInfo['member_id'] ){
			$canEdit = true;
		}else{
			$canEdit = false;
		}
		
		if( $canEdit ){
			$editOption = $option;
			$editOption['forum_mmoo_self'] = $postInfo['id'];
			$editHref = forum_mmoo_make_content_url( 'edit_post' , $editOption );
			$editButton = $this->makeButton($postId, 'edit', 'Edit', $editHref);
			if( $childNum == 0 ){
				$deleteHref = forum_mmoo_make_content_url('delete_post',array('forum_mmoo_topic'=>$this->topicInfo['id'], 'forum_mmoo_post'=>$postInfo['id']));
				$deleteButton = $this->makeButton($postId, 'delete', 'Delete', $deleteHref);
			}else{
				$deleteButton = $this->makeButton($postId, 'delete', "This post has replies and you can't delete it.", "", 'delete_cant', true);
			}
		}else{
			$editButton = '';
			$deleteButton = '';
		}
		
		if( $postInfo['depth']==0 && $this->generalInfo['fold_independent']==FORUM_MMOO_FLAG_YES ){
			$toggle = true;
		}elseif( $postInfo['depth']>0 && $this->generalInfo['fold_reply']==FORUM_MMOO_FLAG_YES ){
			$toggle = true;
		}else{
			$toggle = false;
		}
		$titleMatched = false;
		foreach( $this->arrSearch as $word ){
			if( preg_match('|'.$word.'|', $postInfo['content'])){
				$postInfo['content'] = str_replace($word, '<span class="forum_mmoo-post_searched_word">'.$word.'</span>', $postInfo['content']);
				$toggle = false;
			}
			
			if( preg_match('|'.$word.'|', $postInfo['title'])){
				$postInfo['title'] = str_replace($word, '</span><span class="forum_mmoo-post_searched_word">'.$word.'</span><span class="forum_mmoo-post_title">', $postInfo['title']);
				$titleMatched = true;
			}
		}
		if($postInfo['id']==$this->request['forum_mmoo_post']){
			$toggle = false;
		}
		
		if( $toggle ){
			$showButton = '<a class="forum_mmoo-psudo_button" style="margin-right:0;" onClick="jQuery(\'#forum_mmoo-post_content_box_'.$postInfo['id'].'\').toggle();">See Content</a>';
			$display = ' display:none;';
		}else{
			$showButton = '';
			$display = '';
		}
		
		$notifyOption = $option;
		$notifyOption['forum_mmoo_post'] = $postInfo['id'];
		$startNotifyHref = forum_mmoo_make_content_url('notify_reply',array_merge($notifyOption, array('change'=>'start')));
		$stopNotifyHref = forum_mmoo_make_content_url('notify_reply',array_merge($notifyOption, array('change'=>'stop')));
		if( $this->notifyPosts[$postInfo['id']] ){
			$notifyButton = $this->makeButton($postId, 'notify', 'Stop notifying mails', $stopNotifyHref, 'notify_stop');
		}elseif( $canReply && $this->memberInfo['notify_own']==FORUM_MMOO_FLAG_YES ){
			$notifyButton = $this->makeButton($postId, 'notify', 'Receive notify mails when this post get replied', $startNotifyHref);
		}elseif( $canReply && $this->memberInfo['notify_other']==FORUM_MMOO_FLAG_YES && $postInfo['posted_by']==$this->memberInfo['member_id'] ){
			$notifyButton = $this->makeButton($postId, 'notify', 'Receive notify mails when this post get replied', $startNotifyHref);
		}else{
			$notifyButton = '';
		}
		
		if( $postInfo['depth']<5 ){
			$marginLeft = 3 * $postInfo['depth'];
		}else{
			$marginLeft = 12 + 1.2 * ($postInfo['depth'] - 4 );
		}
		$width = 100 - $marginLeft;
		
		$return .= '<div class="forum_mmoo-post_title_box" style="width:'.$width.'%; margin-left:'.$marginLeft.'%;">';
		$return .= '<span class="forum_mmoo-post_show">'.$showButton.'</span>';
		if( !$titleMatched ){
			$postInfo['title'] = forum_mmoo_excerpt($postInfo['title'],FORUM_MMOO_POST_SHORTEN);
		}
		$return .= '<span class="forum_mmoo-post_title">'.$postInfo['title'].'</span>';
		$return .= $replyButton;
		$return .= $notifyButton;
		$return .= $deleteButton;
		$return .= $editButton;
		$return .= '</div>';
		$return .= '<div id="forum_mmoo-post_content_box_'.$postInfo['id'].'" class="forum_mmoo-post_content_box" style="width:'.$width.'%; margin-left:'.$marginLeft.'%;'.$display.'">';
		$return .= '<span class="forum_mmoo-post_by"> by : '.$this->getMemberLink($postInfo['posted_by']).'</span>';
		if( $postInfo['posted_date'] != $postInfo['updated_time'] ){
			$return .= '<span class="forum_mmoo-post_update">last update : '.forum_mmoo_convert_datetime($postInfo['updated_time']).'</span>';
		}
		$return .= '<span class="forum_mmoo-post_update">posted : '.forum_mmoo_convert_datetime($postInfo['posted_date']).'</span>';
		$return .= '<br><hr>';
		$return .= $postInfo['content'];
		$return .= '</div>';
		
		return $return;
	}
	
	function getFullForm($branch){
		$return = '';
		foreach($branch as $postId => $children){
			$return .= $this->getPostDiv($postId, count($children));
			if( !empty($children) ){
				$return .= $this->getFullForm($children);
			}
		}
		return $return;
	}
}
?>