<?php
class forum_mmoo_content_profile extends forum_mmoo_content{
	var $viewerId;
	var $targetId;
	var $shortendHN;
	
	function __construct($request=array()){
		parent::__construct($request);
		
		unset($request['act']);
		$this->outputSocialButtonsUrl = forum_mmoo_make_content_url('profile', $request);
		
		$this->viewerId = $this->memberInfo['member_id'];
		if( empty($request['forum_mmoo_member']) && !empty($this->viewerId) ){
			$this->targetId = $this->viewerId;
		}else{
			$this->targetId = $request['forum_mmoo_member'];
		}
		
		include_once(FORUM_MMOO_DATA_DIR.'data_members.php');
		$objMembers = new forum_mmoo_data_members();
		$this->profileInfo = $objMembers->getMemberInfoById($this->targetId,'strict');
		if( strlen($this->profileInfo['hn'])==0 ){
			$this->profileInfo['hn'] = FORUM_MMOO_HN_ANONYMOUS;
		}
		
		$this->shortendHN = forum_mmoo_excerpt($this->profileInfo['hn'], FORUM_MMOO_HN_SHORTEN);
	}
	
	function setBackPage(){
		$backPage = array();
		
		if( $this->viewerId == $this->targetId ){
			$backPage['act'] = 'edit_profile';
			$backPage['option'] = array();
			$backPage['text'] = 'Profile';
		}else{
			$backPage['act'] = 'profile';
			$backPage['option'] = array('forum_mmoo_member'=>$this->targetId );
			$backPage['text'] = $this->shortendHN."'s profile";
		}
		forum_mmoo_set_session( 'backPage', $backPage );
	}
	
	function setOutputMain(){
		if( $this->viewerId == $this->targetId ){
			$this->outputMain .= $this->copyOutputMain('edit_profile');
		}elseif( empty($this->profileInfo['id']) ){
			$this->outputMain .= '<p class="forum_mmoo-alert">This member has left the forum.<p>';
		}else{
			$this->outputMain .= '<span class="forum_mmoo-page_title">'.$this->shortendHN."'s profile</span>";
			if( $this->memberInfo['send_message']==FORUM_MMOO_FLAG_YES ){
				include_once(FORUM_MMOO_DATA_DIR.'data_group.php');
				$objGroup = new forum_mmoo_data_group;
				$targetGroupData = $objGroup->getGroupData($this->profileInfo['group_id']);
				if( $targetGroupData['send_message'] == FORUM_MMOO_FLAG_YES ){
					$this->outputMain .= '&nbsp;&nbsp;&nbsp;&nbsp;<a href="'.forum_mmoo_make_content_url('message',array('forum_mmoo_current'=>'new_message','to_member_id'=>$this->targetId)).'">>>send a message</a>';
				}else{
					$this->outputMain .= '&nbsp;&nbsp;&nbsp;&nbsp;This member is not allowed to receive messages.';
				}
			}
			
			if( $this->memberInfo['read_profile']==FORUM_MMOO_FLAG_NO ){
				$this->outputMain .= '<p class="forum_mmoo-alert">'.FORUM_MMOO_MUST_LOGIN_MESSAGE.' to view profiles.<p>';
			}else{
				include_once(FORUM_MMOO_DATA_DIR.'data_member_info.php');
				$objMemberInfo = new forum_mmoo_data_member_info();
				
				include_once( FORUM_MMOO_CONTENT_DIR.'content_register.php');
				$objRegister = new forum_mmoo_content_register();
				
				$this->outputMain .= '<table class="forum_mmoo-table_profile">';
				$this->outputMain .= $objRegister->getConfirmTable($objMemberInfo->getData(true,true), $this->profileInfo);
				$this->outputMain .= '</table>';
			}
		}
	}
}
?>