<?php
include_once(FORUM_MMOO_DATA_DIR.'_data.php');

class forum_mmoo_data_general extends forum_mmoo_data{
	function __construct(){
		parent::__construct('general');
		
		$this->sort_post = array(
			'desc' => array('flag'=>'1', 'text'=>'New to Old')
			, 'asc' => array('flag'=>'2', 'text'=>'Old to New')
		);
		
		$this->sort_topic = array(
			'id_desc' => array('flag'=>'1', 'text'=>'New to Old (created)', 'sql'=>' ORDER BY id desc ')
			, 'id_asc' => array('flag'=>'2', 'text'=>'Old to New (created)', 'sql'=>' ORDER BY id asc ')
			, 'update_desc' => array('flag'=>'3', 'text'=>'New to Old (update)', 'sql'=>' ORDER BY updated_time desc ')
			, 'update_asc' => array('flag'=>'4', 'text'=>'Old to New (update)', 'sql'=>' ORDER BY updated_time asc ')
		);
	}
	
	function setAllFields(){
		$fields = array(
			'max_depth' => array('col_name'=>'max_depth', 'type'=>'char', 'length'=>2, 'default'=>FORUM_MMOO_FLAG_INFINIT)
			, 'max_reply' => array('col_name'=>'max_reply', 'type'=>'char', 'length'=>2, 'default'=>FORUM_MMOO_FLAG_INFINIT)
			, 'per_topic' => array('col_name'=>'per_topic', 'type'=>'char', 'length'=>2, 'default'=>FORUM_MMOO_FLAG_INFINIT)
			, 'per_topic_cnt_reply' => array('col_name'=>'per_topic_cnt_reply', 'type'=>'char', 'length'=>1, 'default'=>FORUM_MMOO_FLAG_NO)
			, 'per_page' => array('col_name'=>'per_page', 'type'=>'char', 'length'=>2, 'default'=>10)
			, 'topic_per_page' => array('col_name'=>'topic_per_page', 'type'=>'char', 'length'=>2, 'default'=>10)
			, 'sort_post' => array('col_name'=>'sort_post', 'type'=>'char', 'length'=>1, 'default'=>$this->sort_post['asc']['flag']) 
			, 'sort_topic' => array('col_name'=>'sort_topic', 'type'=>'char', 'length'=>1, 'default'=>$this->sort_topic['update_desc']['flag']) 
			, 'fold_independent' => array('col_name'=>'fold_independent', 'type'=>'char', 'length'=>1, 'default'=>FORUM_MMOO_FLAG_NO)
			, 'fold_reply' => array('col_name'=>'fold_reply', 'type'=>'char', 'length'=>1, 'default'=>FORUM_MMOO_FLAG_YES)
			, 'password_reminder' => array('col_name'=>'password_reminder', 'type'=>'char', 'length'=>1, 'default'=>FORUM_MMOO_FLAG_YES)
			, 'social' => array('col_name'=>'social', 'type'=>'text')
		);
		$this->setField($fields);
	}
	
	function setDefaultRows(){
		$this->default_rows = array(
			array('updated_time' => $this->now )
		);
	}
	
	function getData(){
		$result = $this->executeSelectOne();
		$result = $this->decodeFlag('sort_post','sort_post',$result);
		return $this->decodeFlag('sort_topic','sort_topic',$result);
	}
	
	function saveData($row){
		$row = $this->encodeFlag('sort_post','sort_post',$row);
		$row = $this->encodeFlag('sort_topic','sort_topic',$row);
		return $this->executeUpdate($row, array('id'=>1), true);
	}
}
?>