<?php
include_once(FORUM_MMOO_DATA_DIR.'_data.php');
class forum_mmoo_data_group extends forum_mmoo_data{
	function __construct(){
		parent::__construct('group');
		
		$this->group_num = 20;
		$this->max_id = 20;
		$this->allow_type = array(
			'guest' => array('flag'=>'00', 'text'=>'Guest')
			, 'immediate' => array('flag'=>'10', 'text'=>'Immediate')
			, 'email' => array('flag'=>'20', 'text'=>'Mail')
			, 'admin' => array('flag'=>'30', 'text'=>'Manual')
			, 'secret' => array('flag'=>'99', 'text'=>'Dummy')
		);
	}
	
	function setAllFields(){
		$fields = array(
			'group_name' => array('col_name'=>'group_name', 'type'=>'varchar', 'length'=>200)
			, 'read_only' => array('col_name'=>'read_only', 'type'=>'char', 'length'=>1, 'default'=>FORUM_MMOO_FLAG_YES)
			, 'read_profile' => array('col_name'=>'read_profile', 'type'=>'char', 'length'=>1, 'default'=>FORUM_MMOO_FLAG_NO)
			, 'post' => array('col_name'=>'post', 'type'=>'char', 'length'=>1, 'default'=>FORUM_MMOO_FLAG_NO)
			, 'create_topic' => array('col_name'=>'create_topic', 'type'=>'char', 'length'=>1, 'default'=>FORUM_MMOO_FLAG_NO)
			, 'delete_topic' => array('col_name'=>'delete_topic', 'type'=>'char', 'length'=>1, 'default'=>FORUM_MMOO_FLAG_NO)
			, 'edit_own' => array('col_name'=>'edit_own', 'type'=>'char', 'length'=>1, 'default'=>FORUM_MMOO_FLAG_YES)
			, 'edit_other' => array('col_name'=>'edit_other', 'type'=>'char', 'length'=>1, 'default'=>FORUM_MMOO_FLAG_NO)
			, 'notify_own' => array('col_name'=>'notify_own', 'type'=>'char', 'length'=>1, 'default'=>FORUM_MMOO_FLAG_NO)
			, 'notify_other' => array('col_name'=>'notify_other', 'type'=>'char', 'length'=>1, 'default'=>FORUM_MMOO_FLAG_NO)
			, 'notify_update' => array('col_name'=>'notify_update', 'type'=>'char', 'length'=>1, 'default'=>FORUM_MMOO_FLAG_NO)
			, 'send_message' => array('col_name'=>'send_message', 'type'=>'char', 'length'=>1, 'default'=>FORUM_MMOO_FLAG_YES)
			, 'notify_message' => array('col_name'=>'notify_message', 'type'=>'char', 'length'=>1, 'default'=>FORUM_MMOO_FLAG_YES)
			, 'allow' => array('col_name'=>'allow', 'type'=>'char', 'length'=>2,'default'=>$this->allow_type['immediate']['flag'])
		);
		$this->setField($fields);
	}
	
	function getAuthParams(){
		$return = array();
		$this->setAllFields();
		foreach( $this->fields as $key => $val ){
			if( $val['default']==FORUM_MMOO_FLAG_YES || $val['default']==FORUM_MMOO_FLAG_NO ){
				$return[] = $key;
			}
		}
		return $return;
	}
	
	function setDefaultRows(){
		$this->default_rows = array(
			array(
				'group_name' => 'Guest'
				, 'read_only' => FORUM_MMOO_FLAG_YES
				, 'read_profile' => FORUM_MMOO_FLAG_NO
				, 'post' => FORUM_MMOO_FLAG_NO
				, 'create_topic' => FORUM_MMOO_FLAG_NO
				, 'delete_topic' => FORUM_MMOO_FLAG_NO
				, 'edit_own' => FORUM_MMOO_FLAG_NO
				, 'edit_other' => FORUM_MMOO_FLAG_NO
				, 'notify_own' => FORUM_MMOO_FLAG_NO
				, 'notify_other' => FORUM_MMOO_FLAG_NO
				, 'notify_update' => FORUM_MMOO_FLAG_NO
				, 'send_message' => FORUM_MMOO_FLAG_NO
				, 'notify_message' => FORUM_MMOO_FLAG_NO
				, 'allow' => $this->allow_type['guest']['flag']
			), array(
				'group_name' => 'Normal'
				, 'read_only' => FORUM_MMOO_FLAG_YES
				, 'read_profile' => FORUM_MMOO_FLAG_YES
				, 'post' => FORUM_MMOO_FLAG_YES
				, 'create_topic' => FORUM_MMOO_FLAG_NO
				, 'delete_topic' => FORUM_MMOO_FLAG_NO
				, 'edit_own' => FORUM_MMOO_FLAG_YES
				, 'edit_other' => FORUM_MMOO_FLAG_NO
				, 'notify_own' => FORUM_MMOO_FLAG_YES
				, 'notify_other' => FORUM_MMOO_FLAG_NO
				, 'notify_update' => FORUM_MMOO_FLAG_NO
				, 'send_message' => FORUM_MMOO_FLAG_YES
				, 'notify_message' => FORUM_MMOO_FLAG_YES
				, 'allow' => $this->allow_type['immediate']['flag']
			), array(
				'group_name' => 'Privileged'
				, 'read_only' => FORUM_MMOO_FLAG_YES
				, 'read_profile' => FORUM_MMOO_FLAG_YES
				, 'post' => FORUM_MMOO_FLAG_YES
				, 'create_topic' => FORUM_MMOO_FLAG_YES
				, 'delete_topic' => FORUM_MMOO_FLAG_NO
				, 'edit_own' => FORUM_MMOO_FLAG_YES
				, 'edit_other' => FORUM_MMOO_FLAG_NO
				, 'notify_own' => FORUM_MMOO_FLAG_YES
				, 'notify_other' => FORUM_MMOO_FLAG_NO
				, 'notify_update' => FORUM_MMOO_FLAG_YES
				, 'send_message' => FORUM_MMOO_FLAG_YES
				, 'notify_message' => FORUM_MMOO_FLAG_YES
				, 'allow' => $this->allow_type['admin']['flag']
			), array(
				'group_name' => 'Administrators'
				, 'read_only' => FORUM_MMOO_FLAG_YES
				, 'read_profile' => FORUM_MMOO_FLAG_YES
				, 'post' => FORUM_MMOO_FLAG_YES
				, 'create_topic' => FORUM_MMOO_FLAG_YES
				, 'delete_topic' => FORUM_MMOO_FLAG_YES
				, 'edit_own' => FORUM_MMOO_FLAG_YES
				, 'edit_other' => FORUM_MMOO_FLAG_YES
				, 'notify_own' => FORUM_MMOO_FLAG_YES
				, 'notify_other' => FORUM_MMOO_FLAG_YES
				, 'notify_update' => FORUM_MMOO_FLAG_YES
				, 'send_message' => FORUM_MMOO_FLAG_YES
				, 'notify_message' => FORUM_MMOO_FLAG_YES
				, 'allow' => $this->allow_type['secret']['flag']
			)
		);
	}
	
	function getData(){
		$return = array();
		$max = 0;
		$cnt = 0;
		$res = $this->executeSelect('','',' ORDER BY id asc ');
		foreach($res as $key => $row){
			if( !empty($row) ){
				$return[$cnt] = $this->decodeFlag('allow','allow_type', $row);
				$cnt++;
				$max = $row['id'];
			}
		}
		for($i; $i<$this->group_num-$cnt; $i++){
			$max ++;
			$return[$max] = array();
		}
		$this->max_id = $max;
		return $return;
	}
	
	function saveData($rows){
		for($i=1; $i<$this->max_id; $i++){
			if( empty($rows[$i]) ){
				$where = array('id'=>$i);
				if( !$this->executeDelete($where) ){
					return false;
				}
			}else{
				$set = $this->encodeFlag('allow','allow_type',$rows[$i]);
				$where = array('id'=>$i);
				$this->executeUpdate($set,$where,true);
			}
		}
		return true;
	}
	
	function getGroupData($groupId){
		$row = $this->executeSelectOne( '', array('id'=>$groupId) );
		return $this->decodeFlag('allow','allow_type',$row);
	}
	
	function getGuestData(){
		$row = $this->executeSelectOne( '', array('allow'=>$this->allow_type['guest']['flag']) );
		return $this->decodeFlag('allow','allow_type',$row);
	}
	
	function getGroupsNoneGuest(){
		$notin = array(
			'allow' => array(
				'not in'=>array(
					$this->allow_type['guest']['flag']
					, $this->allow_type['secret']['flag']
				)
			)
		);
		$res = $this->executeSelect( '', $notin, ' ORDER BY id asc ' );
		$return = array();
		foreach( $res as $row ){
			$return[] = $this->decodeFlag('allow','allow_type',$row);
		}
		return $return;
	}
}
?>