<?php
include_once(FORUM_MMOO_DATA_DIR.'_data.php');

class forum_mmoo_data_member_info extends forum_mmoo_data{
	function __construct(){
		parent::__construct('member_info');
		
		$this->input_type = array(
			'text' => array('flag'=>1, 'text'=>'Text')
			, 'radio' => array('flag'=>2, 'text'=>'Radio Button')
			, 'select' => array('flag'=>3, 'text'=>'Pulldown Menu')
			, 'check' => array('flag'=>4, 'text'=>'Checkbox')
			, 'date' => array('flag'=>5, 'text'=>'Pulldown Date')
		);
	}
	
	function setAllFields(){
		$fields = array(
			'alive' => array('col_name'=>'alive', 'type'=>'char', 'length'=>1, 'default'=>FORUM_MMOO_FLAG_NO)
			, 'question' => array('col_name'=>'question', 'type'=>'varchar', 'length'=>256 )
			, 'required' => array('col_name'=>'required', 'type'=>'char', 'length'=>1, 'default'=>FORUM_MMOO_FLAG_NO)
			, 'allow_duplication' => array('col_name'=>'allow_duplication', 'type'=>'char', 'length'=>1, 'default'=>FORUM_MMOO_FLAG_YES)
			, 'show_in_profile' => array('col_name'=>'show_in_profile', 'type'=>'char', 'length'=>1, 'default'=>FORUM_MMOO_FLAG_YES)
			, 'input_type' => array('col_name'=>'input_type', 'type'=>'char', 'length'=>1, 'default'=>$this->input_type['text']['flag'])
			, 'input_value_range' => array('col_name'=>'input_value_range', 'type'=>'varchar', 'length'=>256)
			, 'change_alive' => array('col_name'=>'change_alive', 'type'=>'char', 'length'=>1, 'default'=>FORUM_MMOO_FLAG_YES)
			, 'change_required' => array('col_name'=>'change_required', 'type'=>'char', 'length'=>1, 'default'=>FORUM_MMOO_FLAG_YES)
			, 'priority' => array('col_name'=>'priority', 'type'=>'char', 'length'=>1, 'default'=>1)
			, 'default_question' => array('col_name'=>'default_question', 'type'=>'varchar', 'length'=>50 )
			, 'member_col_name' => array('col_name'=>'member_col_name', 'type'=>'varchar', 'length'=>50 )
		);
		$this->setField($fields);
	}
	
	function setDefaultRows(){
		$this->default_rows = array(
			array(
				'alive' => FORUM_MMOO_FLAG_YES
				, 'question' => 'loginID'
				, 'required' => FORUM_MMOO_FLAG_YES
				, 'allow_duplication' => FORUM_MMOO_FLAG_NO
				, 'show_in_profile' => FORUM_MMOO_FLAG_NO
				, 'input_type' => $this->input_type['text']['flag']
				, 'change_alive' => FORUM_MMOO_FLAG_YES
				, 'change_required' => FORUM_MMOO_FLAG_NO
				, 'priority' => 9
				, 'default_question' => 'loginID'
				, 'member_col_name' => 'login_id'
			), array(
				'alive' => FORUM_MMOO_FLAG_YES
				, 'question' => 'email'
				, 'required' => FORUM_MMOO_FLAG_YES
				, 'allow_duplication' => FORUM_MMOO_FLAG_NO
				, 'show_in_profile' => FORUM_MMOO_FLAG_NO
				, 'input_type' => $this->input_type['text']['flag']
				, 'change_alive' => FORUM_MMOO_FLAG_NO
				, 'change_required' => FORUM_MMOO_FLAG_NO
				, 'priority' => 9
				, 'default_question' => 'email'
				, 'member_col_name' => 'mail'
			), array(
				'alive' => FORUM_MMOO_FLAG_YES
				, 'question' => 'password'
				, 'required' => FORUM_MMOO_FLAG_YES
				, 'allow_duplication' => FORUM_MMOO_FLAG_YES
				, 'show_in_profile' => FORUM_MMOO_FLAG_NO
				, 'input_type' => $this->input_type['text']['flag']
				, 'change_alive' => FORUM_MMOO_FLAG_NO
				, 'change_required' => FORUM_MMOO_FLAG_NO
				, 'priority' => 9
				, 'default_question' => 'password'
				, 'member_col_name' => 'password'
			), array(
				'alive' => FORUM_MMOO_FLAG_YES
				, 'question' => 'handle name'
				, 'required' => FORUM_MMOO_FLAG_NO
				, 'allow_duplication' => FORUM_MMOO_FLAG_YES
				, 'show_in_profile' => FORUM_MMOO_FLAG_YES
				, 'input_type' => $this->input_type['text']['flag']
				, 'change_alive' => FORUM_MMOO_FLAG_NO
				, 'change_required' => FORUM_MMOO_FLAG_NO
				, 'priority' => 9
				, 'default_question' => 'handle name'
				, 'member_col_name' => 'hn'
			), array(
				'alive' => FORUM_MMOO_FLAG_YES
				, 'question' => 'gender'
				, 'required' => FORUM_MMOO_FLAG_NO
				, 'allow_duplication' => FORUM_MMOO_FLAG_YES
				, 'show_in_profile' => FORUM_MMOO_FLAG_YES
				, 'input_type' => $this->input_type['radio']['flag']
				, 'input_value_range' => 'male,female,else'
			),array(
				'alive' => FORUM_MMOO_FLAG_NO
				, 'question' => 'birthday'
				, 'required' => FORUM_MMOO_FLAG_YES
				, 'allow_duplication' => FORUM_MMOO_FLAG_YES
				, 'show_in_profile' => FORUM_MMOO_FLAG_YES
				, 'input_type' => $this->input_type['date']['flag']
				, 'input_value_range' => '1920,,'.FORUM_MMOO_FLAG_YES.','.FORUM_MMOO_FLAG_YES
			), array(
				'alive' => FORUM_MMOO_FLAG_NO
				, 'question' => 'weight(kg)'
				, 'required' => FORUM_MMOO_FLAG_NO
				, 'allow_duplication' => FORUM_MMOO_FLAG_YES
				, 'show_in_profile' => FORUM_MMOO_FLAG_YES
				, 'input_type' => $this->input_type['select']['flag']
				, 'input_value_range' => '20,100,10'
			)
		);
	}
	
	function getData($onlyAlive=false, $showInProfile=false){
		$return = array();
		$where = array();
		if( $onlyAlive ){
			$where['alive'] = FORUM_MMOO_FLAG_YES;
		}
		if( $showInProfile ){
			$where['show_in_profile'] = FORUM_MMOO_FLAG_YES;
		}
		$result = $this->executeSelect('', $where, " ORDER BY priority desc, id asc ");
		foreach($result as $row){
			$return[$row['id']] = $this->decodeFlag('input_type', 'input_type', $row);
		}
		return $return;
	}
	
	function saveData($rows){
		foreach( $rows as $id => $row ){
			$where = array('id' => $id);
			if( !$this->executeUpdate( $this->encodeFlag('input_type', 'input_type', $row) , $where, true ) ){
				return false;
			}
		}
		return true;
	}
}
?>