<?php
include_once(FORUM_MMOO_DATA_DIR.'_data.php');

class forum_mmoo_data_psudo_session extends forum_mmoo_data{
	function __construct(){
		parent::__construct('psudo_session', false, false);
		
		$this->expireTime = 60*60;
	}
	
	function setAllFields(){
		$fields = array(
			'sid' => array('col_name'=>'sid', 'type'=>'char', 'length'=>50)
			, 'key_name' => array('col_name'=>'key_name', 'type'=>'varchar', 'length'=>50)
			, 'info' => array('col_name'=>'info', 'type'=>'text')
			, 'info_is_array' => array('col_name'=>'info_is_array', 'type'=>'char', 'length'=>1)
			, 'expire' => array('col_name'=>'expire', 'type'=>'char', 'length'=>14)
		);
		$this->setField($fields);
	}
	
	function getData($sid){
		$return = array();
		$result = $this->executeSelect( array('key_name','info', 'info_is_array'), array('sid'=>$sid) );
		foreach($result as $row){
			if( $row['info_is_array'] == FORUM_MMOO_FLAG_YES ){
				$return[$row['key_name']] = unserialize($row['info']);
			}else{
				$return[$row['key_name']] = $row['info'];
			}
		}
		return $return;
	}
	
	function getSession($sid){
		if( empty($sid) ){
			return null;
		}
		$return = $this->getData($sid);
		if( !empty($return) ){
			$newExpire = date('His')+$this->expireTime;
			$this->executeUpdate( array('expire'=>date('Ymd').sprintf('%06d',$newExpire)), array('sid'=>$sid) );
		}
		return $return;
	}
	
	function getCookie($sid){
		if( empty($sid) ){
			return null;
		}
		return $this->getData($sid);
	}
	
	function saveData($sid, $key, $info, $expire){
		if( empty($sid) ){
			return false;
		}
		
		if( is_array($info) ){
			$info = serialize($info);
			$infoIsArray = FORUM_MMOO_FLAG_YES;
		}else{
			$infoIsArray = FORUM_MMOO_FLAG_NO;
		}
		
		return $this->executeUpdate( array('info'=>$info, 'info_is_array'=> $infoIsArray, 'expire'=>$expire), array('sid'=>$sid, 'key_name'=>$key), true );
	}
	
	function saveSession($sid, $key, $info){
		$expire = date('His') + $this->expireTime;
		$expire = date('Ymd').$expire;
		return $this->saveData($sid, $key, $info, $expire);
	}
	
	function saveCookie($sid, $key, $info){
		$expire = '99999999999999';
		return $this->saveData($sid, $key, $info, $expire);
	}
	
	function unsetData($sid, $key=null){
		if( empty($sid) ){
			return false;
		}
		$where = array('sid'=>$sid);
		if( !empty($key) ){
			$where['key_name'] = $key;
		}
		
		return $this->executeDelete( $where );
	}
	
	function unsetSession($sid, $key=null){
		return $this->unsetData($sid, $key);
	}
	
	function unsetCookie($sid, $key=null){
		return $this->unsetData($sid, $key);
	}
	
	function clearGarbage(){
		$this->executeDelete( array('expire'=>array(' < ',date('YmdHis') ) ) );
	}
}
?>
