<?php
function forum_mmoo_make_mail_tag($question){
	return '@@@'.$question.'@@@';
}

function forum_mmoo_get_tags_member(){
	$return = array();
	
	include_once(FORUM_MMOO_DATA_DIR.'data_member_info.php');
	$objMemberInfo = new forum_mmoo_data_member_info();
	$info = $objMemberInfo->getData();
	
	foreach($info as $row){
		if( !empty($row['question']) ){
			$return[$row['question']] = array( 
				'tag'=>forum_mmoo_make_mail_tag($row['question'])
				, 'member_info_id'=>$row['id'] 
			);
		}
	}
	
	return $return;
}

function forum_mmoo_get_tags_url(){
	$return = array();
	$pages = array(
		'URL for the account activation'
		, 'URL for the changed address activation'
		, 'URL of your forum'
		, 'URL of the topic'
		, 'URL of the post'
		, 'URL of the message'
	);
	foreach( $pages as $page ){
		$return[$page] = forum_mmoo_make_mail_tag($page);
	}
	return $return;
}

function forum_mmoo_get_tags_special(){
	$return = array();
	$return['Sign-In Info'] = forum_mmoo_make_mail_tag('Sign-In Info');
	return $return;
}

function forum_mmoo_replace_mail_tag($text, $arrId=array()){
	include_once(FORUM_MMOO_FUNCTIONS_DIR.'content_url.php');
	
	$useLoginId = false;
	$loginIdCol = array();
	$passwordCol = array();
	
	include_once(FORUM_MMOO_DATA_DIR.'data_member_info.php');
	$objMemberInfo = new forum_mmoo_data_member_info();
	$colInfo = $objMemberInfo->getData();
	foreach( $colInfo as $info ){
		if( !empty($loginIdCol) && !empty($passwordCol) && !empty($randIdCol) ){
			break;
		}
		
		if( $info['member_col_name']=='login_id' ){
			$loginIdCol['question'] = $info['question'];
			$loginIdCol['id'] = $info['id'];
			if( $info['alive']==FORUM_MMOO_FLAG_YES ){
				$useLoginId = true;
			}
		}
		
		if( $info['member_col_name']=='password' ){
			$passwordCol['question'] = $info['question'];
			$passwordCol['id'] = $info['id'];
		}
	}
	
	$memberId = ( isset($arrId['member_id']) ) ? $arrId['member_id'] : null;
	$topicId = ( isset($arrId['topic_id']) ) ? $arrId['topic_id'] : null;
	$postId = ( isset($arrId['post_id']) ) ? $arrId['post_id'] : null;
	$blogPage = ( isset($arrId['blog_page']) ) ? $arrId['blog_page'] : get_the_ID();
	
	$tagsMember = forum_mmoo_get_tags_member();
	$tagsUrl = forum_mmoo_get_tags_url();
	$tagsSpecial = forum_mmoo_get_tags_special();
	
	$memberInfo = array();
	if( !empty($memberId) ){
		include_once(FORUM_MMOO_DATA_DIR.'data_members.php');
		$objMembers = new forum_mmoo_data_members();
		
		if( is_array($memberId) ){
			$arrMemberId = $memberId;
		}else{
			$arrMemberId = array($memberId);
		}
		
		foreach( $arrMemberId as $id ){
			$memberInfoRaw = $objMembers->getMemberInfoById($id,'all');
			$objMembers->setAllFields();
			
			foreach( $tagsMember as $key => $tagInfo ){
				$value = $memberInfoRaw[$objMembers->colNames[$tagInfo['member_info_id']]];
				if( $colInfo[$tagInfo['member_info_id']]['input_type'] == 'date' ){
					$year = substr($value,0,4);
					$month = substr($value,4,2);
					$day = substr($value,6,2);
					$value = '';
					if( $year!=FORUM_MMOO_FLAG_ZERO.FORUM_MMOO_FLAG_ZERO ){
						$value .= (int)$year.' ';
					}
					if( $month!=FORUM_MMOO_FLAG_ZERO ){
						$value .= strftime("%B", strtotime($month."/23/2000")).' ';
					}
					if( $day!=FORUM_MMOO_FLAG_ZERO ){
						$value .= (int)$day;
					}
				}
				$memberInfo[$key][] = $value;
			}
			
			$loginData = '';
			if( $useLoginId ){
				$loginData .= $loginIdCol['question'].' : '.$memberInfoRaw[$objMembers->colNames[$loginIdCol['id']]];
				if( count($arrMemberId) > 1 ){
					$loginData .= ' , ';
				}else{
					$loginData .= "\n";
				}
			}
			$loginData .= $passwordCol['question'].' : '.$memberInfoRaw[$objMembers->colNames[$passwordCol['id']]];
			$memberInfo['login_info'][] = $loginData;
			
			if( count($arrMemberId)==1 ){
				$randId = $memberInfoRaw['rand_id'];
			}
		}
	}
	
	if( !empty($memberInfo) ){
		foreach($tagsMember as $key => $tagInfo){
			$text = str_replace($tagInfo['tag'], implode(' , ',$memberInfo[$key]), $text);
		}
		$text = str_replace($tagsSpecial['Sign-In Info'], implode("\n",$memberInfo['login_info']), $text);
	}else{
		foreach($tagsMember as $tagInfo){
			$text = str_replace($tagInfo['tag'], '', $text);
		}
		$text = str_replace($tagsSpecial['Sign-In Info'], '', $text);
	}
	
	if( !empty($randId) ){
		$text = str_replace($tagsUrl['URL for the account activation'], forum_mmoo_make_content_url('mail_confirm', array('rand_id'=>$randId), $blogPage), $text);
	}else{
		$text = str_replace($tagsUrl['URL for the account activation'], '', $text);
	}
	
	if( !empty($memberId) && !is_array($memberId) ){
		include_once(FORUM_MMOO_DATA_DIR.'data_mail_change.php');
		$objMailChange = new forum_mmoo_data_mail_change();
		$mailChangeInfo = $objMailChange->getData($memberId);
	}
	if( !empty($mailChangeInfo['rand_id']) ){
		$text = str_replace($tagsUrl['URL for the changed address activation'], forum_mmoo_make_content_url('mail_change', array('rand_id'=>$mailChangeInfo['rand_id']), $blogPage), $text);
	}else{
		$text = str_replace($tagsUrl['URL for the changed address activation'], '', $text);
	}
	
	$text = str_replace($tagsUrl['URL of your forum'], forum_mmoo_make_content_url('','',$blogPage), $text);
	$text = str_replace($tagsUrl['URL of the message'], forum_mmoo_make_content_url('message','',$blogPage), $text);
	
	if( !empty($topicId) ){
		$text = str_replace($tagsUrl['URL of the topic'], forum_mmoo_make_content_url('posts', array('forum_mmoo_topic'=>$topicId), $blogPage), $text);
	}else{
		$text = str_replace($tagsUrl['URL of the topic'], '', $text);
	}
	if( !empty($postId) ){
		$text = str_replace($tagsUrl['URL of the post'], forum_mmoo_make_content_url('posts', array('forum_mmoo_topic'=>$topicId, 'forum_mmoo_post'=>$postId), $blogPage), $text);
	}else{
		$text = str_replace($tagsUrl['URL of the post'], '', $text);
	}
	
	$text = preg_replace('/@@@.*@@@/','',$text);
	
	return $text;
}

function forum_mmoo_mail($to, $subject, $content){
	$result = wp_mail($to, $subject, $content);
	
	if( !$result || FORUM_MMOO_DEBUG ){
		include_once(FORUM_MMOO_FUNCTIONS_DIR.'debug.php');
		$message = "\n!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n";
		$message .= " SENT AT : ".date('Y-m-d H:i:s')."\n";
		$message .= " TO :".$to."\n";
		$message .= " SUBJECT : ".$subject."\n";
		$message .= "----------------\n";
		$message .= $content;
		forum_mmoo_debug_write('mail', $message);
	}
	
	return $result;
}
?>
